diff -pruN 5.9.2-1/CMakeLists.txt 5.10.0-1/CMakeLists.txt
--- 5.9.2-1/CMakeLists.txt	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/CMakeLists.txt	2021-01-12 08:58:14.000000000 +0000
@@ -1,7 +1,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 cmake_minimum_required(VERSION 3.7.2)
-project("Crispy Doom" VERSION 5.9.2 LANGUAGES C)
+project("Crispy Doom" VERSION 5.10.0 LANGUAGES C)
 
 # Autotools variables
 set(top_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
diff -pruN 5.9.2-1/configure.ac 5.10.0-1/configure.ac
--- 5.9.2-1/configure.ac	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/configure.ac	2021-01-12 08:58:14.000000000 +0000
@@ -1,9 +1,9 @@
-AC_INIT(Crispy Doom, 5.9.2,
+AC_INIT(Crispy Doom, 5.10.0,
         fabian@greffrath.com, crispy-doom)
 
 PACKAGE_SHORTNAME=${PACKAGE_NAME% Doom}
 PACKAGE_SHORTDESC="Limit-removing enhanced-resolution Doom source port"
-PACKAGE_COPYRIGHT="Copyright (C) 1993-2020"
+PACKAGE_COPYRIGHT="Copyright (C) 1993-2021"
 PACKAGE_LICENSE="GNU General Public License, version 2"
 PACKAGE_MAINTAINER="Fabian Greffrath"
 PACKAGE_URL="http://fabiangreffrath.github.io/crispy-doom"
@@ -18,7 +18,7 @@ orig_CFLAGS="$CFLAGS"
 AM_PROG_AR
 AC_PROG_CC
 AC_PROG_RANLIB
-AC_CHECK_PROG(HAVE_PYTHON, python, true, false)
+AC_CHECK_PROG(HAVE_PYTHON, python3, true, false)
 
 OPT_LEVEL=2
 
@@ -136,9 +136,10 @@ AS_IF([test "x$with_libpng" != xno], [
 # [crispy] true-color rendering as a compile-time option
 AC_ARG_ENABLE([truecolor],
 AS_HELP_STRING([--enable-truecolor],
-    [true-color rendering (experimental) @<:@default=no@:>@]),
-AC_DEFINE([CRISPY_TRUECOLOR], [1], [true-color rendering])
-)
+    [true-color rendering (experimental) @<:@default=no@:>@]))
+AS_IF([test "x$enable_truecolor" = "xyes"], [
+    AC_DEFINE([CRISPY_TRUECOLOR], [1], [true-color rendering])
+])
 
 # TODO: We currently link everything against libraries that don't need it.
 # Use the specific library CFLAGS/LIBS variables instead of setting them here.
diff -pruN 5.9.2-1/data/convert-icon 5.10.0-1/data/convert-icon
--- 5.9.2-1/data/convert-icon	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/data/convert-icon	2021-01-12 08:58:14.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 #
 # Copyright(C) 2005-2014 Simon Howard
 #
diff -pruN 5.9.2-1/debian/changelog 5.10.0-1/debian/changelog
--- 5.9.2-1/debian/changelog	2020-10-02 07:04:57.000000000 +0000
+++ 5.10.0-1/debian/changelog	2021-01-27 21:39:21.000000000 +0000
@@ -1,3 +1,13 @@
+crispy-doom (5.10.0-1) unstable; urgency=medium
+
+  * Recommend freedoom instead of freedm.
+  * Bump Breaks against the freedoom package to a version which is
+    known to be Vanilla (and thus Crispy) Doom compatible.
+  * New upstream version 5.10.0
+  * Removed all patches applied upstream.
+
+ -- Fabian Greffrath <fabian@debian.org>  Wed, 27 Jan 2021 22:39:21 +0100
+
 crispy-doom (5.9.2-1) unstable; urgency=medium
 
   * New upstream version 5.9.2
diff -pruN 5.9.2-1/debian/control 5.10.0-1/debian/control
--- 5.9.2-1/debian/control	2020-10-02 07:00:44.000000000 +0000
+++ 5.10.0-1/debian/control	2021-01-01 16:13:30.000000000 +0000
@@ -24,8 +24,10 @@ Depends:
  ${misc:Depends},
  ${shlibs:Depends}
 Recommends:
- freedm | game-data-packager
+ freedoom | game-data-packager
 Provides: doom-engine
+Breaks:
+ freedoom (<< 0.12.1)
 Description: Limit-raising medium-resolution Doom engine based on Chocolate Doom
  Crispy Doom is a friendly fork of Chocolate Doom that provides a higher display
  resolution, removes the static limits of the Doom engine and offers further
diff -pruN 5.9.2-1/debian/patches/0003-prevent-crashes-with-simultaneous-use-of-record-and-.patch 5.10.0-1/debian/patches/0003-prevent-crashes-with-simultaneous-use-of-record-and-.patch
--- 5.9.2-1/debian/patches/0003-prevent-crashes-with-simultaneous-use-of-record-and-.patch	2020-10-02 05:53:13.000000000 +0000
+++ 5.10.0-1/debian/patches/0003-prevent-crashes-with-simultaneous-use-of-record-and-.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,26 +0,0 @@
-From 211dd1a8b36dc5fecd4bc5149f54ffc1a6a85315 Mon Sep 17 00:00:00 2001
-From: Fabian Greffrath <fabian@greffrath.com>
-Date: Tue, 22 Sep 2020 12:18:33 +0200
-Subject: [PATCH 3/4] prevent crashes with simultaneous use of -record and
- -pistolstart
-
-Thanks Spie812.
----
- src/doom/g_game.c | 1 +
- 1 file changed, 1 insertion(+)
-
-diff --git a/src/doom/g_game.c b/src/doom/g_game.c
-index 934d8bf7..84332889 100644
---- a/src/doom/g_game.c
-+++ b/src/doom/g_game.c
-@@ -886,6 +886,7 @@ void G_DoLoadLevel (void)
-             const char message[] = "The -pistolstart option is not suppported"
-                                    " for demos and\n"
-                                    " network play.";
-+            if (!demo_p) demorecording = false;
-             I_Error(message);
-         }
-     }
--- 
-2.28.0
-
diff -pruN 5.9.2-1/debian/patches/0004-textscreen-deliberately-create-a-software-renderer.patch 5.10.0-1/debian/patches/0004-textscreen-deliberately-create-a-software-renderer.patch
--- 5.9.2-1/debian/patches/0004-textscreen-deliberately-create-a-software-renderer.patch	2020-10-02 05:53:21.000000000 +0000
+++ 5.10.0-1/debian/patches/0004-textscreen-deliberately-create-a-software-renderer.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,29 +0,0 @@
-From a0e667de8678b045f8f08a7d87ba86239e33fa6b Mon Sep 17 00:00:00 2001
-From: Fabian Greffrath <fabian@greffrath.com>
-Date: Wed, 23 Sep 2020 08:20:39 +0200
-Subject: [PATCH 4/4] textscreen: deliberately create a software renderer
-
-On systems which lack sufficient hardware acceleration capabilities we
-would have no chance to open the setup window otherwise.
-
-Fixes https://github.com/fabiangreffrath/crispy-doom/issues/670.
----
- textscreen/txt_sdl.c | 2 +-
- 1 file changed, 1 insertion(+), 1 deletion(-)
-
-diff --git a/textscreen/txt_sdl.c b/textscreen/txt_sdl.c
-index 91bdffd9..ab6cd4dc 100644
---- a/textscreen/txt_sdl.c
-+++ b/textscreen/txt_sdl.c
-@@ -253,7 +253,7 @@ int TXT_Init(void)
-     if (TXT_SDLWindow == NULL)
-         return 0;
- 
--    renderer = SDL_CreateRenderer(TXT_SDLWindow, -1, 0);
-+    renderer = SDL_CreateRenderer(TXT_SDLWindow, -1, SDL_RENDERER_SOFTWARE);
- 
-     // Special handling for OS X retina display. If we successfully set the
-     // highdpi flag, check the output size for the screen renderer. If we get
--- 
-2.28.0
-
diff -pruN 5.9.2-1/debian/patches/build-with-python3.patch 5.10.0-1/debian/patches/build-with-python3.patch
--- 5.9.2-1/debian/patches/build-with-python3.patch	2019-09-03 10:38:28.000000000 +0000
+++ 5.10.0-1/debian/patches/build-with-python3.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,59 +0,0 @@
-Description: Build with Python 3
-Author: Stephen Kitt <skitt@debian.org>
-
-As indicated upstream in
-https://github.com/chocolate-doom/chocolate-doom/issues/1158 the build
-scripts run with Python 2 or 3; this forces the use of Python 3
-throughout.
-
---- a/configure.ac
-+++ b/configure.ac
-@@ -18,7 +18,7 @@ orig_CFLAGS="$CFLAGS"
- AM_PROG_AR
- AC_PROG_CC
- AC_PROG_RANLIB
--AC_CHECK_PROG(HAVE_PYTHON, python, true, false)
-+AC_CHECK_PROG(HAVE_PYTHON, python3, true, false)
- 
- OPT_LEVEL=2
- 
---- a/data/convert-icon
-+++ b/data/convert-icon
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/python3
- #
- # Copyright(C) 2005-2014 Simon Howard
- #
---- a/man/docgen
-+++ b/man/docgen
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/python3
- # 
- # Chocolate Doom self-documentation tool.  This works similar to javadoc
- # or doxygen, but documents command line parameters and configuration
---- a/man/simplecpp
-+++ b/man/simplecpp
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/python3
- #
- # Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008
- # Contributors to the Freedoom project.  All rights reserved.
---- a/pkg/win32/cp-with-libs
-+++ b/pkg/win32/cp-with-libs
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/python3
- #
- # Copyright(C) 2016 Simon Howard
- #
---- a/textscreen/fonts/convert-font
-+++ b/textscreen/fonts/convert-font
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/python3
- #
- # Copyright(C) 2016 Simon Howard
- #
diff -pruN 5.9.2-1/debian/patches/series 5.10.0-1/debian/patches/series
--- 5.9.2-1/debian/patches/series	2020-10-02 05:53:43.000000000 +0000
+++ 5.10.0-1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-build-with-python3.patch
-0003-prevent-crashes-with-simultaneous-use-of-record-and-.patch
-0004-textscreen-deliberately-create-a-software-renderer.patch
diff -pruN 5.9.2-1/man/docgen 5.10.0-1/man/docgen
--- 5.9.2-1/man/docgen	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/man/docgen	2021-01-12 08:58:14.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 # 
 # Chocolate Doom self-documentation tool.  This works similar to javadoc
 # or doxygen, but documents command line parameters and configuration
diff -pruN 5.9.2-1/man/simplecpp 5.10.0-1/man/simplecpp
--- 5.9.2-1/man/simplecpp	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/man/simplecpp	2021-01-12 08:58:14.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 #
 # Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008
 # Contributors to the Freedoom project.  All rights reserved.
diff -pruN 5.9.2-1/pkg/win32/cp-with-libs 5.10.0-1/pkg/win32/cp-with-libs
--- 5.9.2-1/pkg/win32/cp-with-libs	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/pkg/win32/cp-with-libs	2021-01-12 08:58:14.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 #
 # Copyright(C) 2016 Simon Howard
 #
diff -pruN 5.9.2-1/README.md 5.10.0-1/README.md
--- 5.9.2-1/README.md	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/README.md	2021-01-12 08:58:14.000000000 +0000
@@ -159,133 +159,52 @@ After successful compilation the resulti
 
 ## News
 
-### Crispy Doom 5.9.2
+### Crispy Doom 5.10.0
 
-Crispy Doom 5.9.2 is released on September 22, 2020 to fix some more bugs and add some minor improvements.
+Crispy Doom 5.10.0 is released on Jan 12, 2021. Its major new feature is the addition of support for the widescreen assets found e.g. in the Unity version of Doom.
 
 **New Features and Improvements**
 
- * Support for the "new" Nerve PWAD has been improved: If the Nerve PWAD is explicitly loaded and contains a TITLEPIC lump, use it - else use the INTERPIC lump. Consequently, if the Nerve PWAD gets auto-loaded and contains TITLEPIC and an INTERPIC lumps, rename them (thanks @buvk).
- * Graphic patch lumps in widescreen format are now properly centered - but still squashed to Vanilla aspect ratio (thanks @buvk).
- * A `-pistolstart` command line option has been added (by @mikeday0, thanks @Asais10).
- * The tally screen is now shown after finishing Chex Quest E1M5 (thanks kokrean).
- * Apparently random crashes have been fixed that occured when the (truncated) file name of a loaded demo happens to match the name of an already available lump. Now this lump name collision is detected and the offending demo lump renamed to DEMO1, which is most certainly always the name of a demo lump (thanks galileo31dos01 and plums).
+ * Proper support for widescreen assets has been added (by @SmileTheory, thanks @ghost and @chungy).
+ * The bezel bottom edge to the left and right of the status bar in widescreen mode is now preserved (thanks braders1986 and @SmileTheory).
+ * Special treatment is now applied to the No Rest for the Living and The Masterlevels expansions - even during network games, demo recording and playback. This includes level transitions to the secret maps and back, finale text screens, par times, etc. (thanks Coincident and Keyboard_Doomer for input from the DSDA community).
+ * Menu scrolling with the mouse wheel has been improved to be more responsive (by @JNechaevsky).
+ * All textures are now always composed, whether they are multi-patched or not. Furthermore, two separate composites are created, one for opaque and one for translucent mid-textures on 2S walls. Additionally, textures may now be arbitrarily tall.
+ * Freedoom Phase 2 and FreeDM are now explicitly named in the Doom 2 Episode menu.
+ * The status bar is now redrawn in the Main, Episode and Skill menus, where it could get overridden by custom graphics (thanks @JNechaevsky).
 
 **Bug Fixes**
 
- * The Sigil PWAD is now only pre-loaded if the gameversion is The Ultimate Doom. This fixes a glitched texture file when Chex Quest is loaded as the IWAD (by @kitchen-ace, thanks Mr.Unsmiley)
- * Check if the map name graphics lumps are actually from the Masterlevels PWAD before renaming them. This fixes an issue with unofficial Masterlevels compilations which do not contain these lumps (thanks @Dark-Jaguar).
- * A string buffer size calculation bug has been fixed in the `-levelstat` implementation (thanks Eric Claus).
+ * A crash has been fixed when the -record and -pistolstart parameters were used simultaneously (thanks Spie812).
+ * An optimization inherited from MBF has been fixed which led to sprites not being rendered on the lowest possible floor (thanks @retro65).
+ * Only non-sky flats are now checked for the swirling effect.
+ * Crushed non-bleeding monsters are not removed off the map anymore, their sprites are replaced with the invisible SPR_TNT1 instead (thanks ZeroMaster010 and sorry for the desyncing demo).
+ * Sigil is not auto-loaded anymore with the Freedoom Phase 1 IWAD, since Sigil's own texture definitions may clash with the ones from Freedoom (thanks @Some1NamedNate).
+ * A brightmap definition for an animated flat sequence in HacX has been fixed.
+ * Some fixes to the "--enable-truecolor" configure option have been implemented (i.e. the --disable-truecolor option, the rendering of the status bar bezel, fuzzy column drawing and the translucency factor - thanks xttl).
+ * Window height adjustment when changing window size has been brought back at the cost of the window shrinking when repeatedly changing the widescreen option.
+ * Parts of the status bar being visible during the initial wipe in widescreen mode has been fixed (thanks xttl).
 
 **Crispy Heretic**
 
- * A `-wandstart` command line option has been added (by @mikeday0, thanks @Asais10).
-
-Crispy Doom 5.9.2 is based on Chocolate Doom 3.0.1 and has merged all changes to the Chocolate Doom master branch up to commit [`f7007449`](https://github.com/chocolate-doom/chocolate-doom/commit/f700744969ac867649aa581ae19447a4c172179e).
-
-### Crispy Doom 5.9.1
-
-Crispy Doom 5.9.1 is released on September 04, 2020 to fix some minor bugs.
-
-**Bug Fixes**
-
- * Building without Python has been fixed again (inherited from Chocolate Doom, by @vilhelmgray, thanks Michael Bäuerle).
- * An old bug has been fixed which was caused by SDL2_Mixer opening a different number of audio channels than requested (inherited from Chocolate Doom, thanks Edward850).
- * Auto-loading of the Sigil PWAD has been fixed on file systems with case-sensitive file names (thanks @kitchen-ace and @kbterkelsen).
-
-**Crispy Heretic**
-
- * Final intermissions screens are now shown after each episode (by @kraflab).
-
-Crispy Doom 5.9.1 is based on Chocolate Doom 3.0.1 and has merged all changes to the Chocolate Doom master branch up to commit [`f7007449`](https://github.com/chocolate-doom/chocolate-doom/commit/f700744969ac867649aa581ae19447a4c172179e).
-
-### Crispy Doom 5.9.0
-
-Crispy Doom 5.9.0 is released on August 21, 2020 and introduces auto-loading of both official Doom 2 expansions for any supported Doom 2 IWAD, additional DEHACKED fields to de-hardcode some Vanilla behavior and many other improvements and bug fixes.
-
-**New Features and Improvements**
-
- * NERVE.wad is now automatically loaded even with the Vanilla DOOM2.wad IWAD (thanks @hkight).
- * MASTERLEVELS.wad is now automatically loaded alongside DOOM2.wad just like NERVE.wad was for the BFG Edition DOOM2.wad IWAD before. However, this will now work for *any* DOOM2.wad IWAD as well (thanks @buvk for reporting a bug in the initial implementation).
- * Support has been added for automatically loading all the 20 separate Master Levels PWADs and arranging them as if they came from the single MASTERLEVELS.wad PWAD.
- * Alternative text entries have been added to the skill menu. Thus, the entries are still there and rendered consistently even if the Nightmare! skill graphics lump is missing when playing with a v1.2 or earlier IWAD (thanks @zx64).
- * The unconditional "fixing" of reversed stereo channels in OPL music playback has been reverted. People got so much used to the flipped channels that the correct channel order has been regarded as a bug (thanks @drivetheory).
- * Two separate finale texts for the Master Levels have been introduced, depending on whether you have found and finished the secret MAP21 or not. The actual texts have been taken from @MadDeCoDeR's Classic-RBDOOM-3-BFG project with some minor wording fixes applied (thanks @icecreamoverlord).
- * Optional Automap lines smoothing has been added with a toggle in the Crispness menu (by @zx64).
- * Doors locked with a key now flash on the Automap, if extended map colours are enabled (by @kitchen-ace).
- * Extended map colours have been adjusted to be closer to Vanilla's (by @kitchen-ace).
- * A "use" button timer has been added and can be enabled in the "Demos" Crispness menu section, apparently useful for practicing speed-running (thanks Looper).
- * A check for segs referencing non-existent linedefs has been ported over from PrBoom+ (thanks @tpoppins).
- * Demo joins are now tracked (by @kraflab).
- * Support for the "Dropped Item" DEHACKED field has been added, which allows to specify the Thing Id to be spawned after the Thing dies. It's a generalization of the same behavior that is hardcoded for MT_WOLFSS, MT_POSSESSED, MT_SHOTGUY and MT_CHAINGUY in Vanilla Doom (by @Ferk).
- * More generalizations de-hardcoding some Vanilla Doom behavior have been added (by @Ferk).
-   * The following DEHACKED fields for Things have been added:
-     * Melee threshold: Distance to switch from missile to melee attack.
-     * Max target range: Maximum distance to start shooting (0 for unlimited).
-     * Min missile chance: Minimum chance for firing a missile.
-     * Missile chance multiplier: This de-hardcodes the double missile chance that vanilla Cyberdemon, Spider Mastermind, Revent and Lost Souls have. The value is FRACUNIT based (65536 = normal firing chance), also note that the lower the value, the higher the chance.
- * A `-levelstat` option has been added (by @kraflab).
-
-**Bug Fixes**
-
- * The sky in NRFTL Maps 04-08 is now fixed if loaded from command line (thanks @Zodomaniac).
- * HUD texts are now printed up to the right screen edge again (thanks Grizzly).
- * The DSSECRET fallback sound is now checked for availability. This fixes a crash when playing with a v1.2 or earlier IWAD (thanks @zx64).
- * The HUD widget coordinate re-calculation has been moved from thinker to drawer functions. This should fix the racing condition that caused the wide status bar widget alignment being drawn to the automap status bar with the brick border (thanks @kitchen-ace).
- * The IDCLEV cheat has been fixed for the Master Levels (thanks @buvk).
- * Thing coordinates in the rotated automap have been fixed when the "extended automap colors" feature is disabled (thanks @icecreamoverlord).
- * A segmentation fault has been fixed when changing episodes during the intermission screen (thanks @icecreamoverlord).
- * The "go to next level" cheat key for the Master Levels has been fixed.
- * Endianess issues when loading extended nodes have been fixed (thanks Michael Bäuerle).
- * The IDDT cheat is now reset when restarting a map during demo recording, but not each time the Automap is opened (thanks galileo31dos01).
- * Missing server-side num_players validation (CVE-2020-14983) and missing client-side ticdup validation have been fixed (found by Michał Dardas from LogicalTrust, fixes inherited from Chocolate Doom).
- * Automap panning by keyboard and mouse is now accumulated (thanks @kitchen-ace).
- * Invalid texture/flat animation sequences are now skipped instead of erroring out (thanks @kitchen-ace).
- * The Automap shaking for one frame after changing the view angle has been fixed (thanks @JNechaevsky).
- * The top-right HU widgets have been moved one char to the left to allow for display of multi-thousand FPS (thanks @JNechaevsky).
-
-**Crispy Heretic**
-
- * The alternative WASD movement scheme key bindings have been added (thanks @zx64).
- * The Heretic Crispness menu has been colorized.
- * Morph Ovum is now allowed to be bound to a key (by @kitchen-ace).
- * The chat sound is now played when a secret is found. It's a message after all.
- * Seconds are now always displayed in intermission time, bringing time display in line with Doom (by @kitchen-ace).
- * Level time is now always shown in extended maps, i.e. episodes 4 and above (by @kitchen-ace).
- * The demoextend and shortticfix features are now enabled by default (by @kitchen-ace, also applied to the Hexen sources).
- * Interpolation of the puff object is now suppressed for the first tic, so the snapping of the puff to the floor level isn't interpolated (thanks Wagi).
- * Centered messages are now cleared on intermission and finale screens (by @JNechaevsky).
- * Centered messages are now cleared from border and bezel (by @JNechaevsky).
- * Top border refresh has been fixed for centered messages (by @JNechaevsky).
- * Support dedicated music tracks for each map has been added (by @kitchen-ace, thanks Dwars).
- * The ENGAGExy cheat (and some others) are now allowed in Nightmare.
-   * Cheats enabled in Black Plague Possesses Thee, i.e. Heretic's Nightmare (by @kitchen-ace):
-     * ENGAGExy: warp to level
-     * NOISE: sound debug info
-   * Cheats enabled in BPPT as well as netgames:
-     * TICKER: show ticks-per-frame counter
-     * SHOWFPS: show FPS counter (Crispy specific cheat)
- * Key bindings to restart the level/demo and go to next level have been added (by @kitchen-ace).
- * A `-levelstat` option has been added (by @kraflab).
- * Total level time is now tracked for levelstat and is also added to the intermission screen  (by @kraflab).
+ * The level restart key now restarts the current demo recording from the map it was started, but under a new name (thanks @thom-wye).
+ * Demo file names may now have arbitrary length (inherited from Chocolate Doom, also applied to the Hexen sources).
+ * The demo file size limit has been removed (also applied to the Hexen and Strife sources).
+ * The top border not always being drawn correctly in hires mode for all reduced screen sizes has been fixed (thanks @xttl).
 
 **Known Issues**
 
- * When the 20 separate Master Levels PWADs are automatically loaded, their individual sky textures have to get removed, else they would override the regular sky textures for Doom 2 and NRFTL (thanks @tpoppins for noticing). If you insist to play the Master Levels each with their designated sky, load the individual PWADs on the command line.
+ * Users who insist on the pure Vanilla experience that was formerly applied to the No Rest for the Living and The Masterlevels expansions or who need it to properly play back demos recorded with a previous release will have to rename their PWAD files and explicitly load them on the command line.
 
-Crispy Doom 5.9.0 is based on Chocolate Doom 3.0.1 and has merged all changes to the Chocolate Doom master branch up to commit [`6ba89d0c`](https://github.com/chocolate-doom/chocolate-doom/commit/6ba89d0c05e4b93bdb64460b64a9ba3bdcc4bf6e).
+Crispy Doom 5.10.0 is based on Chocolate Doom 3.0.1 and has merged all changes to the Chocolate Doom master branch up to commit [`b26157ac`](https://github.com/chocolate-doom/chocolate-doom/commit/b26157aca5b12049b35d8dfcf969c51967a369f6).
 
-## Documentation
+## More documentation
 
  * **[Changelog](https://github.com/fabiangreffrath/crispy-doom/wiki/Changelog)**
  * **[Compatibility](https://github.com/fabiangreffrath/crispy-doom/wiki/Compatibility)**
  * **[Crispness](https://github.com/fabiangreffrath/crispy-doom/wiki/Crispness)**
  * **[FAQ](https://github.com/fabiangreffrath/crispy-doom/wiki/FAQ)**
 
-## Versioning
-
-Crispy Doom's major version number is increased whenever a new Chocolate Doom (pre-)release got merged into its code base. The minor version number is increased for intermediate releases that do only contain Crispy-specific changes or unreleased changes to the Chocolate Doom code base. The micro or patch version is reserved for post-release hotfixes, it remained unused until the 5.5 release.
-
 ## Contact
 
 The canonical homepage for Crispy Doom is https://github.com/fabiangreffrath/crispy-doom
diff -pruN 5.9.2-1/src/crispy.c 5.10.0-1/src/crispy.c
--- 5.9.2-1/src/crispy.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/crispy.c	2021-01-12 08:58:14.000000000 +0000
@@ -28,6 +28,9 @@ static crispy_t crispy_s = {
 	.hires = 1,
 	.smoothscaling = 1,
 	.soundfix = 1,
+#ifdef CRISPY_TRUECOLOR
+	.truecolor = 1,
+#endif
 	.vsync = 1,
 };
 crispy_t *const crispy = &crispy_s;
diff -pruN 5.9.2-1/src/crispy.h 5.10.0-1/src/crispy.h
--- 5.9.2-1/src/crispy.h	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/crispy.h	2021-01-12 08:58:14.000000000 +0000
@@ -74,7 +74,7 @@ typedef struct
 	int soundfull;
 	int soundmono;
 	int translucency;
-#if CRISPY_TRUECOLOR
+#ifdef CRISPY_TRUECOLOR
 	int truecolor;
 #endif
 	int uncapped;
@@ -222,4 +222,14 @@ enum
     NUM_WIDGETS
 };
 
+enum
+{
+    RATIO_4_3,
+    RATIO_MATCH_SCREEN,
+    RATIO_16_10,
+    RATIO_16_9,
+    RATIO_21_9,
+    NUM_RATIOS
+};
+
 #endif
diff -pruN 5.9.2-1/src/d_iwad.c 5.10.0-1/src/d_iwad.c
--- 5.9.2-1/src/d_iwad.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/d_iwad.c	2021-01-12 08:58:14.000000000 +0000
@@ -208,6 +208,30 @@ static registry_value_t root_path_keys[]
         SOFTWARE_KEY "\\GOG.com\\Games\\1432899949",
         "PATH",
     },
+
+    // Heretic
+
+    {
+        HKEY_LOCAL_MACHINE,
+        SOFTWARE_KEY "\\GOG.com\\Games\\1290366318",
+        "PATH",
+    },
+
+    // Hexen
+
+    {
+        HKEY_LOCAL_MACHINE,
+        SOFTWARE_KEY "\\GOG.com\\Games\\1247951670",
+        "PATH",
+    },
+
+    // Hexen: Deathkings of a Dark Citadel
+
+    {
+        HKEY_LOCAL_MACHINE,
+        SOFTWARE_KEY "\\GOG.com\\Games\\1983497091",
+        "PATH",
+    },
 };
 
 // Subdirectories of the above install path, where IWADs are installed.
diff -pruN 5.9.2-1/src/doom/d_main.c 5.10.0-1/src/doom/d_main.c
--- 5.9.2-1/src/doom/d_main.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/d_main.c	2021-01-12 08:58:14.000000000 +0000
@@ -1875,7 +1875,9 @@ void D_DoomMain (void)
     // [crispy] allow overriding of special-casing
     if (!M_ParmExists("-noautoload") && gamemode != shareware)
     {
-	if (gamemode == retail && gameversion == exe_ultimate)
+	if (gamemode == retail &&
+	    gameversion == exe_ultimate &&
+	    gamevariant != freedoom)
 	{
 		D_LoadSigilWad();
 	}
diff -pruN 5.9.2-1/src/doom/f_finale.c 5.10.0-1/src/doom/f_finale.c
--- 5.9.2-1/src/doom/f_finale.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/f_finale.c	2021-01-12 08:58:14.000000000 +0000
@@ -148,15 +148,6 @@ void F_StartFinale (void)
             screen->level = 5;
         }
 
-        // [crispy] During demo recording/playback or network games
-        // these two packs behave like any other ordinary PWAD
-        if (!crispy->singleplayer &&
-            (gamemission == pack_nerve || gamemission == pack_master)
-            && screen->mission == doom2)
-        {
-            screen->mission = gamemission;
-        }
-
         if (logical_gamemission == screen->mission
          && (logical_gamemission != doom || gameepisode == screen->episode)
          && gamemap == screen->level)
@@ -212,10 +203,10 @@ void F_Ticker (void)
 				
       if (i < MAXPLAYERS)
       {	
-	if (gamemission == pack_nerve && crispy->singleplayer && gamemap == 8)
+	if (gamemission == pack_nerve && gamemap == 8)
 	  F_StartCast ();
 	else
-	if (gamemission == pack_master && crispy->singleplayer && (gamemap == 20 || gamemap == 21))
+	if (gamemission == pack_master && (gamemap == 20 || gamemap == 21))
 	  F_StartCast ();
 	else
 	if (gamemap == 30)
@@ -890,8 +881,8 @@ F_DrawPatchCol
     pixel_t*	desttop;
     int		count;
 	
-    column = (column_t *)((byte *)patch + LONG(patch->columnofs[col >> FRACBITS]));
-    desttop = I_VideoBuffer + x + (WIDESCREENDELTA << crispy->hires);
+    column = (column_t *)((byte *)patch + LONG(patch->columnofs[col]));
+    desttop = I_VideoBuffer + x;
 
     // step through the posts in a column
     while (column->topdelta != 0xff )
@@ -924,19 +915,43 @@ void F_BunnyScroll (void)
     char	name[10];
     int		stage;
     static int	laststage;
+    int         p2offset, p1offset, pillar_width;
 		
     dxi = (ORIGWIDTH << FRACBITS) / NONWIDEWIDTH;
     dy = (SCREENHEIGHT << FRACBITS) / ORIGHEIGHT;
     dyi = (ORIGHEIGHT << FRACBITS) / SCREENHEIGHT;
 
+    p1 = W_CacheLumpName (DEH_String("PFUB2"), PU_LEVEL);
+    p2 = W_CacheLumpName (DEH_String("PFUB1"), PU_LEVEL);
+
     // [crispy] fill pillarboxes in widescreen mode
-    if (SCREENWIDTH != NONWIDEWIDTH)
+    pillar_width = (SCREENWIDTH - (p1->width << FRACBITS) / dxi) / 2;
+
+    if (pillar_width > 0)
+    {
+        V_DrawFilledBox(0, 0, pillar_width, SCREENHEIGHT, 0);
+        V_DrawFilledBox(SCREENWIDTH - pillar_width, 0, pillar_width, SCREENHEIGHT, 0);
+    }
+    else
     {
-	V_DrawFilledBox(0, 0, SCREENWIDTH, SCREENHEIGHT, 0);
+        pillar_width = 0;
     }
 
-    p1 = W_CacheLumpName (DEH_String("PFUB2"), PU_LEVEL);
-    p2 = W_CacheLumpName (DEH_String("PFUB1"), PU_LEVEL);
+    // Calculate the portion of PFUB2 that would be offscreen at original res.
+    p1offset = (ORIGWIDTH - p1->width) / 2;
+
+    if (p2->width == ORIGWIDTH)
+    {
+        // Unity or original PFUBs.
+        // PFUB1 only contains the pixels that scroll off.
+        p2offset = ORIGWIDTH - p1offset;
+    }
+    else
+    {
+        // Widescreen mod PFUBs.
+        // Right side of PFUB2 and left side of PFUB1 are identical.
+        p2offset = ORIGWIDTH + p1offset;
+    }
 
     V_MarkRect (0, 0, SCREENWIDTH, SCREENHEIGHT);
 	
@@ -945,14 +960,15 @@ void F_BunnyScroll (void)
 	scrolled = ORIGWIDTH;
     if (scrolled < 0)
 	scrolled = 0;
-    scrolled <<= FRACBITS;
-		
-    for ( x=0 ; x<ORIGWIDTH << FRACBITS; x+=dxi)
+
+    for (x = pillar_width; x < SCREENWIDTH - pillar_width; x++)
     {
-	if (x+scrolled < ORIGWIDTH << FRACBITS)
-	    F_DrawPatchCol (x/dxi, p1, x+scrolled);
-	else
-	    F_DrawPatchCol (x/dxi, p2, x+scrolled - (ORIGWIDTH << FRACBITS));
+        int x2 = ((x * dxi) >> FRACBITS) - WIDESCREENDELTA + scrolled;
+
+        if (x2 < p2offset)
+            F_DrawPatchCol (x, p1, x2 - p1offset);
+        else
+            F_DrawPatchCol (x, p2, x2 - p2offset);
     }
 	
     if (finalecount < 1130)
diff -pruN 5.9.2-1/src/doom/g_game.c 5.10.0-1/src/doom/g_game.c
--- 5.9.2-1/src/doom/g_game.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/g_game.c	2021-01-12 08:58:14.000000000 +0000
@@ -883,9 +883,10 @@ void G_DoLoadLevel (void)
         }
         else
         {
-            const char message[] = "The -pistolstart option is not suppported"
+            const char message[] = "The -pistolstart option is not supported"
                                    " for demos and\n"
                                    " network play.";
+            if (!demo_p) demorecording = false;
             I_Error(message);
         }
     }
@@ -1835,7 +1836,7 @@ void G_DoCompleted (void)
     wminfo.last = gamemap -1;
     
     // wminfo.next is 0 biased, unlike gamemap
-    if ( gamemission == pack_nerve && gamemap <= 9 && crispy->singleplayer )
+    if ( gamemission == pack_nerve && gamemap <= 9 )
     {
 	if (secretexit)
 	    switch(gamemap)
@@ -1850,7 +1851,7 @@ void G_DoCompleted (void)
 	    }
     }
     else
-    if ( gamemission == pack_master && gamemap <= 21 && crispy->singleplayer )
+    if ( gamemission == pack_master && gamemap <= 21 )
     {
 	wminfo.next = gamemap;
     }
@@ -1937,8 +1938,8 @@ void G_DoCompleted (void)
         {
             wminfo.partime = TICRATE*bex_cpars[gamemap-1];
         }
-        // [crispy] single player par times for NRFTL
-        else if (gamemission == pack_nerve && crispy->singleplayer)
+        // [crispy] par times for NRFTL
+        else if (gamemission == pack_nerve)
         {
             wminfo.partime = TICRATE*npars[gamemap-1];
         }
@@ -2015,7 +2016,7 @@ void G_WorldDone (void)
       if (!crispy->havee1m10 || gameepisode != 1 || gamemap != 1)
 	players[consoleplayer].didsecret = true; 
 
-    if ( gamemission == pack_nerve && crispy->singleplayer )
+    if ( gamemission == pack_nerve )
     {
 	switch (gamemap)
 	{
@@ -2025,7 +2026,7 @@ void G_WorldDone (void)
 	}
     }
     else
-    if ( gamemission == pack_master && crispy->singleplayer )
+    if ( gamemission == pack_master )
     {
 	switch (gamemap)
 	{
@@ -2510,8 +2511,6 @@ G_InitNew
     defdemotics = 0;
     demostarttic = gametic; // [crispy] fix revenant internal demo bug
 
-    viewactive = true;
-
     // Set the sky to use.
     //
     // Note: This IS broken, but it is how Vanilla Doom behaves.
diff -pruN 5.9.2-1/src/doom/m_crispy.c 5.10.0-1/src/doom/m_crispy.c
--- 5.9.2-1/src/doom/m_crispy.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/m_crispy.c	2021-01-12 08:58:14.000000000 +0000
@@ -135,6 +135,15 @@ multiitem_t multiitem_widgets[NUM_WIDGET
     {WIDGETS_ALWAYS, "always"},
 };
 
+multiitem_t multiitem_widescreen[NUM_RATIOS] =
+{
+    {RATIO_4_3, "4:3"},
+    {RATIO_MATCH_SCREEN, "Match screen"},
+    {RATIO_16_10, "16:10"},
+    {RATIO_16_9, "16:9"},
+    {RATIO_21_9, "21:9"},
+};
+
 extern void AM_LevelInit (boolean reinit);
 extern void EnableLoadingDisk (void);
 extern void P_SegLengths (boolean contrast_only);
@@ -537,7 +546,7 @@ void M_CrispyToggleWeaponSquat(int choic
 
 static void M_CrispyToggleWidescreenHook (void)
 {
-    crispy->widescreen = !crispy->widescreen;
+    crispy->widescreen = (crispy->widescreen + 1) % NUM_RATIOS;
 
     // [crispy] no need to re-init when switching from wide to compact
     {
diff -pruN 5.9.2-1/src/doom/m_crispy.h 5.10.0-1/src/doom/m_crispy.h
--- 5.9.2-1/src/doom/m_crispy.h	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/m_crispy.h	2021-01-12 08:58:14.000000000 +0000
@@ -41,6 +41,7 @@ extern multiitem_t multiitem_sndchannels
 extern multiitem_t multiitem_secretmessage[NUM_SECRETMESSAGE];
 extern multiitem_t multiitem_translucency[NUM_TRANSLUCENCY];
 extern multiitem_t multiitem_widgets[NUM_WIDGETS];
+extern multiitem_t multiitem_widescreen[NUM_RATIOS];
 
 extern void M_CrispyToggleAutomapstats(int choice);
 extern void M_CrispyToggleBobfactor(int choice);
diff -pruN 5.9.2-1/src/doom/m_menu.c 5.10.0-1/src/doom/m_menu.c
--- 5.9.2-1/src/doom/m_menu.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/m_menu.c	2021-01-12 08:58:14.000000000 +0000
@@ -1236,6 +1236,9 @@ void M_MusicVol(int choice)
 //
 void M_DrawMainMenu(void)
 {
+    // [crispy] force status bar refresh
+    inhelpscreens = true;
+
     V_DrawPatchDirect(94, 2,
                       W_CacheLumpName(DEH_String("M_DOOM"), PU_CACHE));
 }
@@ -1248,6 +1251,9 @@ void M_DrawMainMenu(void)
 //
 void M_DrawNewGame(void)
 {
+    // [crispy] force status bar refresh
+    inhelpscreens = true;
+
     V_DrawPatchDirect(96, 14, W_CacheLumpName(DEH_String("M_NEWG"), PU_CACHE));
     V_DrawPatchDirect(54, 38, W_CacheLumpName(DEH_String("M_SKILL"), PU_CACHE));
 }
@@ -1282,6 +1288,9 @@ int     epi;
 
 void M_DrawEpisode(void)
 {
+    // [crispy] force status bar refresh
+    inhelpscreens = true;
+
     V_DrawPatchDirect(54, 38, W_CacheLumpName(DEH_String("M_EPISOD"), PU_CACHE));
 }
 
@@ -1480,7 +1489,7 @@ static void M_DrawCrispness1(void)
 
     M_DrawCrispnessSeparator(crispness_sep_rendering, "Rendering");
     M_DrawCrispnessItem(crispness_hires, "High Resolution Rendering", crispy->hires, true);
-    M_DrawCrispnessItem(crispness_widescreen, "Widescreen Rendering", crispy->widescreen, aspect_ratio_correct);
+    M_DrawCrispnessMultiItem(crispness_widescreen, "Widescreen Aspect Ratio", multiitem_widescreen, crispy->widescreen, aspect_ratio_correct);
     M_DrawCrispnessItem(crispness_uncapped, "Uncapped Framerate", crispy->uncapped, true);
     M_DrawCrispnessItem(crispness_vsync, "Enable VSync", crispy->vsync, !force_software_renderer);
     M_DrawCrispnessItem(crispness_smoothscaling, "Smooth Pixel Scaling", crispy->smoothscaling, true);
@@ -2389,13 +2398,13 @@ boolean M_Responder (event_t* ev)
 	    if (mousebprevweapon >= 0 && ev->data1 & (1 << mousebprevweapon))
 	    {
 		key = key_menu_down;
-		mousewait = I_GetTime() + 5;
+		mousewait = I_GetTime() + 1;
 	    }
 	    else
 	    if (mousebnextweapon >= 0 && ev->data1 & (1 << mousebnextweapon))
 	    {
 		key = key_menu_up;
-		mousewait = I_GetTime() + 5;
+		mousewait = I_GetTime() + 1;
 	    }
 	}
 	else
@@ -3124,8 +3133,15 @@ void M_Init (void)
         int i;
 
         NewDef.prevMenu = &EpiDef;
-        EpisodeMenu[0].alphaKey = 'h';
-        EpisodeMenu[0].alttext = "Hell on Earth";
+        EpisodeMenu[0].alphaKey = gamevariant == freedm ||
+                                  gamevariant == freedoom ?
+                                 'f' :
+                                 'h';
+        EpisodeMenu[0].alttext = gamevariant == freedm ?
+                                 "FreeDM" :
+                                 gamevariant == freedoom ?
+                                 "Freedoom: Phase 2" :
+                                 "Hell on Earth";
         EpiDef.numitems = 1;
 
         if (crispy->havenerve)
diff -pruN 5.9.2-1/src/doom/p_enemy.c 5.10.0-1/src/doom/p_enemy.c
--- 5.9.2-1/src/doom/p_enemy.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/p_enemy.c	2021-01-12 08:58:14.000000000 +0000
@@ -1342,7 +1342,15 @@ void A_VileTarget (mobj_t*	actor)
     fog->tracer = actor->target;
     // [crispy] play DSFLAMST sound when Arch-Vile spawns fire attack
     if (crispy->soundfix && I_GetSfxLumpNum(&S_sfx[sfx_flamst]) != -1)
+    {
 	S_StartSound(fog, sfx_flamst);
+	// [crispy] make DSFLAMST sound uninterruptible
+	if (crispy->soundfull)
+	{
+		S_UnlinkSound(fog);
+	}
+    }
+
     A_Fire (fog);
 }
 
@@ -1730,7 +1738,7 @@ void A_BossDeath (mobj_t* mo)
     {
 	if (gamemap != 7 &&
 	// [crispy] Master Levels in PC slot 7
-	!(crispy->singleplayer && gamemission == pack_master && (gamemap == 14 || gamemap == 15 || gamemap == 16)))
+	!(gamemission == pack_master && (gamemap == 14 || gamemap == 15 || gamemap == 16)))
 	    return;
 		
 	if ((mo->type != MT_FATSO)
@@ -1775,7 +1783,7 @@ void A_BossDeath (mobj_t* mo)
     {
 	if (gamemap == 7 ||
 	// [crispy] Master Levels in PC slot 7
-	(crispy->singleplayer && gamemission == pack_master && (gamemap == 14 || gamemap == 15 || gamemap == 16)))
+	(gamemission == pack_master && (gamemap == 14 || gamemap == 15 || gamemap == 16)))
 	{
 	    if (mo->type == MT_FATSO)
 	    {
@@ -1894,8 +1902,7 @@ void A_BrainAwake (mobj_t* mo)
     // find all the target spots
     numbraintargets = 0;
     braintargeton = 0;
-	
-    thinker = thinkercap.next;
+
     for (thinker = thinkercap.next ;
 	 thinker != &thinkercap ;
 	 thinker = thinker->next)
diff -pruN 5.9.2-1/src/doom/p_map.c 5.10.0-1/src/doom/p_map.c
--- 5.9.2-1/src/doom/p_map.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/p_map.c	2021-01-12 08:58:14.000000000 +0000
@@ -1540,10 +1540,13 @@ boolean PIT_ChangeSector (mobj_t*	thing)
     // crunch bodies to giblets
     if (thing->health <= 0)
     {
+	P_SetMobjState (thing, S_GIBS);
+
 	// [crispy] no blood, no giblets
-	// S_GIBS should be a "safe" state, and so is S_NULL
-	// TODO: Add a check for DEHACKED states
-	P_SetMobjState (thing, (thing->flags & MF_NOBLOOD) ? S_NULL : S_GIBS);
+	if (crispy->coloredblood && (thing->flags & MF_NOBLOOD))
+	{
+		thing->sprite = SPR_TNT1;
+	}
 
     if (gameversion > exe_doom_1_2)
 	    thing->flags &= ~MF_SOLID;
diff -pruN 5.9.2-1/src/doom/p_mobj.c 5.10.0-1/src/doom/p_mobj.c
--- 5.9.2-1/src/doom/p_mobj.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/p_mobj.c	2021-01-12 08:58:14.000000000 +0000
@@ -968,7 +968,7 @@ void P_SpawnMapThing (mapthing_t* mthing
 	return;
     }
 
-    // check for apropriate skill level
+    // check for appropriate skill level
     if (!netgame && (mthing->options & 16) )
 	return;
 		
diff -pruN 5.9.2-1/src/doom/p_pspr.c 5.10.0-1/src/doom/p_pspr.c
--- 5.9.2-1/src/doom/p_pspr.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/p_pspr.c	2021-01-12 08:58:14.000000000 +0000
@@ -981,13 +981,12 @@ void P_MovePsprites (player_t* player)
 {
     int		i;
     pspdef_t*	psp;
-    state_t*	state;
 	
     psp = &player->psprites[0];
     for (i=0 ; i<NUMPSPRITES ; i++, psp++)
     {
 	// a null state means not active
-	if ( (state = psp->state) )	
+	if (psp->state)
 	{
 	    // drop tic count and possibly change state
 
@@ -1006,6 +1005,8 @@ void P_MovePsprites (player_t* player)
 
     // [crispy] apply bobbing (or centering) to the player's weapon sprite
     psp = &player->psprites[0];
+    psp->sx2 = psp->sx;
+    psp->sy2 = psp->sy;
     if (psp->state)
     {
 	// [crispy] don't center vertically during lowering and raising states
@@ -1013,8 +1014,6 @@ void P_MovePsprites (player_t* player)
 	    psp->state->action.acp3 == (actionf_p3)A_Lower ||
 	    psp->state->action.acp3 == (actionf_p3)A_Raise)
 	{
-		psp->sx2 = psp->sx;
-		psp->sy2 = psp->sy;
 	}
 	else
 	// [crispy] not attacking means idle
@@ -1034,11 +1033,6 @@ void P_MovePsprites (player_t* player)
 		psp->sy2 = WEAPONTOP;
 	}
     }
-    else
-    {
-	psp->sx2 = psp->sx;
-	psp->sy2 = psp->sy;
-    }
 
 	// [crispy] squat down weapon sprite a bit after hitting the ground
 	if (player->psp_dy_max)
diff -pruN 5.9.2-1/src/doom/p_telept.c 5.10.0-1/src/doom/p_telept.c
--- 5.9.2-1/src/doom/p_telept.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/p_telept.c	2021-01-12 08:58:14.000000000 +0000
@@ -70,7 +70,6 @@ EV_Teleport
     {
 	if (sectors[ i ].tag == tag )
 	{
-	    thinker = thinkercap.next;
 	    for (thinker = thinkercap.next;
 		 thinker != &thinkercap;
 		 thinker = thinker->next)
diff -pruN 5.9.2-1/src/doom/r_bmaps.c 5.10.0-1/src/doom/r_bmaps.c
--- 5.9.2-1/src/doom/r_bmaps.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_bmaps.c	2021-01-12 08:58:14.000000000 +0000
@@ -842,7 +842,7 @@ void R_InitBrightmaps ()
 		bmapflatnum[5] = R_FlatNumForName("NUKAGE3");
 		bmapflatnum[6] = R_FlatNumForName("BLOOD1");
 		bmapflatnum[7] = R_FlatNumForName("BLOOD2");
-		bmapflatnum[8] = R_FlatNumForName("BLOOD2");
+		bmapflatnum[8] = R_FlatNumForName("BLOOD3");
 		bmapflatnum[9] = R_FlatNumForName("SLIME13");
 		bmapflatnum[10] = R_FlatNumForName("SLIME14");
 		bmapflatnum[11] = R_FlatNumForName("SLIME15");
diff -pruN 5.9.2-1/src/doom/r_data.c 5.10.0-1/src/doom/r_data.c
--- 5.9.2-1/src/doom/r_data.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_data.c	2021-01-12 08:58:14.000000000 +0000
@@ -147,13 +147,15 @@ texture_t**     textures_hashtable;
 
 
 int*			texturewidthmask;
+int*			texturewidth; // [crispy] texture width for wrapping column getter function
 // needed for texture pegging
-fixed_t*		textureheight;		
+fixed_t*		textureheight; // [crispy] texture height for Tutti-Frutti fix
 int*			texturecompositesize;
 short**			texturecolumnlump;
-unsigned**		texturecolumnofs; // killough 4/9/98: make 32-bit
-unsigned**		texturecolumnofs2; // [crispy] original column offsets for single-patched textures
-byte**			texturecomposite;
+unsigned**		texturecolumnofs; // [crispy] column offsets for composited translucent mid-textures on 2S walls
+unsigned**		texturecolumnofs2; // [crispy] column offsets for composited opaque textures
+byte**			texturecomposite; // [crispy] composited translucent mid-textures on 2S walls
+byte**			texturecomposite2; // [crispy] composited opaque textures
 byte**			texturebrightmap; // [crispy] brightmaps
 
 // for global animation
@@ -257,7 +259,7 @@ R_DrawColumnInCache
 
 void R_GenerateComposite (int texnum)
 {
-    byte*		block;
+    byte*		block, *block2;
     texture_t*		texture;
     texpatch_t*		patch;	
     patch_t*		realpatch;
@@ -267,7 +269,7 @@ void R_GenerateComposite (int texnum)
     int			i;
     column_t*		patchcol;
     short*		collump;
-    unsigned*		colofs; // killough 4/9/98: make 32-bit
+    unsigned*		colofs, *colofs2; // killough 4/9/98: make 32-bit
     byte*		marks; // killough 4/9/98: transparency marks
     byte*		source; // killough 4/9/98: temporary column
 	
@@ -276,19 +278,22 @@ void R_GenerateComposite (int texnum)
     block = Z_Malloc (texturecompositesize[texnum],
 		      PU_STATIC, 
 		      &texturecomposite[texnum]);	
+    // [crispy] memory block for opaque textures
+    block2 = Z_Malloc (texture->width * texture->height,
+		      PU_STATIC,
+		      &texturecomposite2[texnum]);
 
     collump = texturecolumnlump[texnum];
     colofs = texturecolumnofs[texnum];
+    colofs2 = texturecolumnofs2[texnum];
     
-    // Composite the columns together.
-    patch = texture->patches;
-		
     // killough 4/9/98: marks to identify transparent regions in merged textures
     marks = calloc(texture->width, texture->height);
 
-    // [crispy] initialize composite background to black (index 0)
+    // [crispy] initialize composite background to palette index 0 (usually black)
     memset(block, 0, texturecompositesize[texnum]);
 
+    // Composite the columns together.
     for (i=0 , patch = texture->patches;
 	 i<texture->patchcount;
 	 i++, patch++)
@@ -333,21 +338,27 @@ void R_GenerateComposite (int texnum)
     source = I_Realloc(NULL, texture->height); // temporary column
     for (i = 0; i < texture->width; i++)
     {
-	if (collump[i] == -1) // process only multipatched columns
+	// [crispy] generate composites for all columns
+//	if (collump[i] == -1) // process only multipatched columns
 	{
 	    column_t *col = (column_t *)(block + colofs[i] - 3); // cached column
 	    const byte *mark = marks + i * texture->height;
 	    int j = 0;
+	    // [crispy] absolut topdelta for first 254 pixels, then relative
+	    int abstop, reltop = 0;
+	    boolean relative = false;
 
 	    // save column in temporary so we can shuffle it around
 	    memcpy(source, (byte *) col + 3, texture->height);
+	    // [crispy] copy composited columns to opaque texture
+	    memcpy(block2 + colofs2[i], source, texture->height);
 
 	    for ( ; ; ) // reconstruct the column by scanning transparency marks
 	    {
 		unsigned len; // killough 12/98
 
-		while (j < texture->height && !mark[j]) // skip transparent cells
-		    j++;
+		while (j < texture->height && reltop < 254 && !mark[j]) // skip transparent cells
+		    j++, reltop++;
 
 		if (j >= texture->height) // if at end of column
 		{
@@ -355,18 +366,26 @@ void R_GenerateComposite (int texnum)
 		    break;
 		}
 
-		col->topdelta = j; // starting offset of post
+		// [crispy] absolut topdelta for first 254 pixels, then relative
+		col->topdelta = relative ? reltop : j; // starting offset of post
+
+		// [crispy] once we pass the 254 boundary, topdelta becomes relative
+		if ((abstop = j) >= 254)
+		{
+			relative = true;
+			reltop = 0;
+		}
 
 		// killough 12/98:
 		// Use 32-bit len counter, to support tall 1s multipatched textures
 
-		for (len = 0; j < texture->height && mark[j]; j++)
+		for (len = 0; j < texture->height && reltop < 254 && mark[j]; j++, reltop++)
 		    len++; // count opaque cells
 
 		col->length = len; // killough 12/98: intentionally truncate length
 
 		// copy opaque cells from the temporary back into the column
-		memcpy((byte *) col + 3, source + col->topdelta, len);
+		memcpy((byte *) col + 3, source + abstop, len);
 		col = (column_t *)((byte *) col + len + 4); // next post
 	    }
 	}
@@ -378,6 +397,7 @@ void R_GenerateComposite (int texnum)
     // Now that the texture has been built in column cache,
     //  it is purgable from zone memory.
     Z_ChangeTag (block, PU_CACHE);
+    Z_ChangeTag (block2, PU_CACHE);
 }
 
 
@@ -400,8 +420,7 @@ void R_GenerateLookup (int texnum)
     int			x2;
     int			i;
     short*		collump;
-    unsigned*		colofs; // killough 4/9/98: make 32-bit
-    unsigned*		colofs2; // [crispy] original column offsets
+    unsigned*		colofs, *colofs2; // killough 4/9/98: make 32-bit
     int			csize = 0; // killough 10/98
     int			err = 0; // killough 10/98
 	
@@ -409,11 +428,12 @@ void R_GenerateLookup (int texnum)
 
     // Composited texture not created yet.
     texturecomposite[texnum] = 0;
+    texturecomposite2[texnum] = 0;
     
     texturecompositesize[texnum] = 0;
     collump = texturecolumnlump[texnum];
     colofs = texturecolumnofs[texnum];
-    colofs2 = texturecolumnofs2[texnum]; // [crispy] original column offsets
+    colofs2 = texturecolumnofs2[texnum];
     
     // Now count the number of columns
     //  that are covered by more than one patch.
@@ -423,7 +443,6 @@ void R_GenerateLookup (int texnum)
     postcount = (byte *) Z_Malloc(texture->width, PU_STATIC, &postcount);
     memset (patchcount, 0, texture->width);
     memset (postcount, 0, texture->width);
-    patch = texture->patches;
 
     for (i=0 , patch = texture->patches;
 	 i<texture->patchcount;
@@ -444,7 +463,7 @@ void R_GenerateLookup (int texnum)
 	{
 	    patchcount[x]++;
 	    collump[x] = patch->patch;
-	    colofs[x] = colofs2[x] = LONG(realpatch->columnofs[x-x1])+3; // [crispy] original column offsets
+	    colofs[x] = LONG(realpatch->columnofs[x-x1])+3;
 	}
     }
 	
@@ -460,7 +479,8 @@ void R_GenerateLookup (int texnum)
     // only one post per column. This avoids crashes while allowing
     // for arbitrarily tall multipatched 1s textures.
 
-    if (texture->patchcount > 1 && texture->height < 256)
+    // [crispy] generate composites for all textures
+//  if (texture->patchcount > 1 && texture->height < 256)
     {
 	// killough 12/98: Warn about a common column construction bug
 	unsigned limit = texture->height * 3 + 3; // absolute column size limit
@@ -479,7 +499,8 @@ void R_GenerateLookup (int texnum)
 
 	    for (x = x1 ; x < x2 ; x++)
 	    {
-		if (patchcount[x] > 1) // Only multipatched columns
+		// [crispy] generate composites for all columns
+//		if (patchcount[x] > 1) // Only multipatched columns
 		{
 		    const column_t *col = (const column_t*)((const byte*) realpatch + LONG(cofs[x]));
 		    const byte *base = (const byte *) col;
@@ -507,11 +528,8 @@ void R_GenerateLookup (int texnum)
 	if (!patchcount[x] && !err++) // killough 10/98: non-verbose output
 	{
 	    // [crispy] fix absurd texture name in error message
-	    char namet[9];
-	    namet[8] = 0;
-	    memcpy (namet, texture->name, 8);
-	    printf ("R_GenerateLookup: column without a patch (%s)\n",
-		    namet);
+	    printf ("R_GenerateLookup: column without a patch (%.8s)\n",
+		    texture->name);
 	    // [crispy] do not return yet
 	    /*
 	    return;
@@ -549,6 +567,8 @@ void R_GenerateLookup (int texnum)
 	    }
 	    */
 	csize += texture->height; // height bytes of texture data
+	// [crispy] initialize opaque texture column offset
+	colofs2[x] = x * texture->height;
     }
 
     texturecompositesize[texnum] = csize;
@@ -566,21 +586,32 @@ void R_GenerateLookup (int texnum)
 byte*
 R_GetColumn
 ( int		tex,
-  int		col,
-  boolean	opaque )
+  int		col )
 {
-    int		lump;
     int		ofs;
-    int		ofs2;
 	
     col &= texturewidthmask[tex];
-    lump = texturecolumnlump[tex][col];
+    ofs = texturecolumnofs2[tex][col];
+
+    if (!texturecomposite2[tex])
+	R_GenerateComposite (tex);
+
+    return texturecomposite2[tex] + ofs;
+}
+
+// [crispy] wrapping column getter function for composited translucent mid-textures on 2S walls
+byte*
+R_GetColumnMod
+( int		tex,
+  int		col )
+{
+    int		ofs;
+
+    while (col < 0)
+	col += texturewidth[tex];
+
+    col %= texturewidth[tex];
     ofs = texturecolumnofs[tex][col];
-    ofs2 = texturecolumnofs2[tex][col];
-    
-    // [crispy] single-patched mid-textures on two-sided walls
-    if (lump > 0 && !opaque)
-	return (byte *)W_CacheLumpNum(lump,PU_CACHE)+ofs2;
 
     if (!texturecomposite[tex])
 	R_GenerateComposite (tex);
@@ -822,8 +853,10 @@ void R_InitTextures (void)
     texturecolumnofs = Z_Malloc (numtextures * sizeof(*texturecolumnofs), PU_STATIC, 0);
     texturecolumnofs2 = Z_Malloc (numtextures * sizeof(*texturecolumnofs2), PU_STATIC, 0);
     texturecomposite = Z_Malloc (numtextures * sizeof(*texturecomposite), PU_STATIC, 0);
+    texturecomposite2 = Z_Malloc (numtextures * sizeof(*texturecomposite2), PU_STATIC, 0);
     texturecompositesize = Z_Malloc (numtextures * sizeof(*texturecompositesize), PU_STATIC, 0);
     texturewidthmask = Z_Malloc (numtextures * sizeof(*texturewidthmask), PU_STATIC, 0);
+    texturewidth = Z_Malloc (numtextures * sizeof(*texturewidth), PU_STATIC, 0);
     textureheight = Z_Malloc (numtextures * sizeof(*textureheight), PU_STATIC, 0);
     texturebrightmap = Z_Malloc (numtextures * sizeof(*texturebrightmap), PU_STATIC, 0);
 
@@ -927,6 +960,8 @@ void R_InitTextures (void)
 
 	texturewidthmask[i] = j-1;
 	textureheight[i] = texture->height<<FRACBITS;
+	// [crispy] texture width for wrapping column getter function
+	texturewidth[i] = texture->width;
 		
 	totalwidth += texture->width;
     }
diff -pruN 5.9.2-1/src/doom/r_data.h 5.10.0-1/src/doom/r_data.h
--- 5.9.2-1/src/doom/r_data.h	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_data.h	2021-01-12 08:58:14.000000000 +0000
@@ -32,8 +32,13 @@
 byte*
 R_GetColumn
 ( int		tex,
-  int		col,
-  boolean	opaque );
+  int		col );
+
+// [crispy] wrapping column getter function for composited translucent mid-textures on 1S walls
+byte*
+R_GetColumnMod
+( int		tex,
+  int		col );
 
 
 // I/O, setting up the stuff.
diff -pruN 5.9.2-1/src/doom/r_draw.c 5.10.0-1/src/doom/r_draw.c
--- 5.9.2-1/src/doom/r_draw.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_draw.c	2021-01-12 08:58:14.000000000 +0000
@@ -414,7 +414,7 @@ void R_DrawFuzzColumn (void)
 #ifndef CRISPY_TRUECOLOR
 	*dest = colormaps[6*256+dest[SCREENWIDTH*fuzzoffset[fuzzpos]]]; 
 #else
-	*dest = I_BlendDark(dest[fuzzoffset[fuzzpos]], 0xc0);
+	*dest = I_BlendDark(dest[SCREENWIDTH*fuzzoffset[fuzzpos]], 0xD3);
 #endif
 
 	// Clamp table lookup index.
@@ -433,7 +433,7 @@ void R_DrawFuzzColumn (void)
 #ifndef CRISPY_TRUECOLOR
 	*dest = colormaps[6*256+dest[SCREENWIDTH*(fuzzoffset[fuzzpos]-FUZZOFF)/2]];
 #else
-	*dest = I_BlendDark(dest[(fuzzoffset[fuzzpos]-FUZZOFF)/2], 0xc0);
+	*dest = I_BlendDark(dest[SCREENWIDTH*(fuzzoffset[fuzzpos]-FUZZOFF)/2], 0xD3);
 #endif
     }
 } 
@@ -500,8 +500,8 @@ void R_DrawFuzzColumnLow (void)
 	*dest = colormaps[6*256+dest[SCREENWIDTH*fuzzoffset[fuzzpos]]];
 	*dest2 = colormaps[6*256+dest2[SCREENWIDTH*fuzzoffset[fuzzpos]]];
 #else
-	*dest = I_BlendDark(dest[fuzzoffset[fuzzpos]], 0xc0);
-	*dest2 = I_BlendDark(dest2[fuzzoffset[fuzzpos]], 0xc0);
+	*dest = I_BlendDark(dest[SCREENWIDTH*fuzzoffset[fuzzpos]], 0xD3);
+	*dest2 = I_BlendDark(dest2[SCREENWIDTH*fuzzoffset[fuzzpos]], 0xD3);
 #endif
 
 	// Clamp table lookup index.
@@ -522,8 +522,8 @@ void R_DrawFuzzColumnLow (void)
 	*dest = colormaps[6*256+dest[SCREENWIDTH*(fuzzoffset[fuzzpos]-FUZZOFF)/2]];
 	*dest2 = colormaps[6*256+dest2[SCREENWIDTH*(fuzzoffset[fuzzpos]-FUZZOFF)/2]];
 #else
-	*dest = I_BlendDark(dest[(fuzzoffset[fuzzpos]-FUZZOFF)/2], 0xc0);
-	*dest2 = I_BlendDark(dest2[(fuzzoffset[fuzzpos]-FUZZOFF)/2], 0xc0);
+	*dest = I_BlendDark(dest[SCREENWIDTH*(fuzzoffset[fuzzpos]-FUZZOFF)/2], 0xD3);
+	*dest2 = I_BlendDark(dest2[SCREENWIDTH*(fuzzoffset[fuzzpos]-FUZZOFF)/2], 0xD3);
 #endif
     }
 } 
diff -pruN 5.9.2-1/src/doom/r_plane.c 5.10.0-1/src/doom/r_plane.c
--- 5.9.2-1/src/doom/r_plane.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_plane.c	2021-01-12 08:58:14.000000000 +0000
@@ -432,7 +432,7 @@ void R_DrawPlanes (void)
 
     for (pl = visplanes ; pl < lastvisplane ; pl++)
     {
-	const boolean swirling = (flattranslation[pl->picnum] == -1);
+	boolean swirling;
 
 	if (pl->minx > pl->maxx)
 	    continue;
@@ -486,13 +486,14 @@ void R_DrawPlanes (void)
 		{
 		    angle = ((an + xtoviewangle[x])^flip)>>ANGLETOSKYSHIFT;
 		    dc_x = x;
-		    dc_source = R_GetColumn(texture, angle, false);
+		    dc_source = R_GetColumn(texture, angle);
 		    colfunc ();
 		}
 	    }
 	    continue;
 	}
 	
+	swirling = (flattranslation[pl->picnum] == -1);
 	// regular flat
         lumpnum = firstflat + (swirling ? pl->picnum : flattranslation[pl->picnum]);
 	// [crispy] add support for SMMU swirling flats
diff -pruN 5.9.2-1/src/doom/r_segs.c 5.10.0-1/src/doom/r_segs.c
--- 5.9.2-1/src/doom/r_segs.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_segs.c	2021-01-12 08:58:14.000000000 +0000
@@ -297,7 +297,7 @@ R_RenderMaskedSegRange
 	    
 	    // draw the texture
 	    col = (column_t *)( 
-		(byte *)R_GetColumn(texnum,maskedtexturecol[dc_x], false) -3);
+		(byte *)R_GetColumnMod(texnum,maskedtexturecol[dc_x]) -3);
 			
 	    R_DrawMaskedColumn (col);
 	    maskedtexturecol[dc_x] = INT_MAX; // [crispy] 32-bit integer math
@@ -407,7 +407,7 @@ void R_RenderSegLoop (void)
 	    dc_yl = yl;
 	    dc_yh = yh;
 	    dc_texturemid = rw_midtexturemid;
-	    dc_source = R_GetColumn(midtexture,texturecolumn,true);
+	    dc_source = R_GetColumn(midtexture,texturecolumn);
 	    dc_texheight = textureheight[midtexture]>>FRACBITS; // [crispy] Tutti-Frutti fix
 	    dc_brightmap = texturebrightmap[midtexture];
 	    colfunc ();
@@ -431,7 +431,7 @@ void R_RenderSegLoop (void)
 		    dc_yl = yl;
 		    dc_yh = mid;
 		    dc_texturemid = rw_toptexturemid;
-		    dc_source = R_GetColumn(toptexture,texturecolumn,true);
+		    dc_source = R_GetColumn(toptexture,texturecolumn);
 		    dc_texheight = textureheight[toptexture]>>FRACBITS; // [crispy] Tutti-Frutti fix
 		    dc_brightmap = texturebrightmap[toptexture];
 		    colfunc ();
@@ -463,7 +463,7 @@ void R_RenderSegLoop (void)
 		    dc_yh = yh;
 		    dc_texturemid = rw_bottomtexturemid;
 		    dc_source = R_GetColumn(bottomtexture,
-					    texturecolumn,true);
+					    texturecolumn);
 		    dc_texheight = textureheight[bottomtexture]>>FRACBITS; // [crispy] Tutti-Frutti fix
 		    dc_brightmap = texturebrightmap[bottomtexture];
 		    colfunc ();
diff -pruN 5.9.2-1/src/doom/r_things.c 5.10.0-1/src/doom/r_things.c
--- 5.9.2-1/src/doom/r_things.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/r_things.c	2021-01-12 08:58:14.000000000 +0000
@@ -713,7 +713,7 @@ void R_ProjectSprite (mobj_t* thing)
     // [JN] killough 4/9/98: clip things which are out of view due to height
     gzt = interpz + spritetopoffset[lump];
     if (interpz > viewz + FixedDiv(viewheight << FRACBITS, xscale) ||
-        gzt < viewz - FixedDiv((viewheight << FRACBITS)-viewheight, xscale))
+        gzt < (int64_t)viewz - FixedDiv((viewheight << FRACBITS)-viewheight, xscale))
     {
 	return;
     }
diff -pruN 5.9.2-1/src/doom/st_stuff.c 5.10.0-1/src/doom/st_stuff.c
--- 5.9.2-1/src/doom/st_stuff.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/st_stuff.c	2021-01-12 08:58:14.000000000 +0000
@@ -497,12 +497,36 @@ void ST_refreshBackground(boolean force)
 		{
 			for (x = 0; x < SCREENWIDTH; x++)
 			{
+#ifndef CRISPY_TRUECOLOR
 				*dest++ = src[((y&63)<<6) + (x&63)];
+#else
+				*dest++ = colormaps[src[((y&63)<<6) + (x&63)]];
+#endif
+			}
+		}
+
+		// [crispy] preserve bezel bottom edge
+		if (scaledviewwidth == SCREENWIDTH)
+		{
+			patch_t *const patch = W_CacheLumpName(DEH_String("brdr_b"), PU_CACHE);
+
+			for (x = 0; x < WIDESCREENDELTA; x += 8)
+			{
+				V_DrawPatch(x - WIDESCREENDELTA, 0, patch);
+				V_DrawPatch(ORIGWIDTH + WIDESCREENDELTA - x - 8, 0, patch);
 			}
 		}
 	}
 
-	V_DrawPatch(ST_X, 0, sbar);
+	// [crispy] center unity rerelease wide status bar
+	if (sbar->width > ORIGWIDTH && sbar->leftoffset == 0)
+	{
+	    V_DrawPatch(ST_X + (ORIGWIDTH - sbar->width) / 2, 0, sbar);
+	}
+	else
+	{
+	    V_DrawPatch(ST_X, 0, sbar);
+	}
 
 	// draw right side of bar if needed (Doom 1.0)
 	if (sbarr)
@@ -520,7 +544,14 @@ void ST_refreshBackground(boolean force)
 	// [crispy] copy entire SCREENWIDTH, to preserve the pattern
 	// to the left and right of the status bar in widescren mode
 	if (!force)
-	V_CopyRect(ST_X, 0, st_backing_screen, SCREENWIDTH >> crispy->hires, ST_HEIGHT, ST_X, ST_Y);
+	{
+	    V_CopyRect(ST_X, 0, st_backing_screen, SCREENWIDTH >> crispy->hires, ST_HEIGHT, ST_X, ST_Y);
+	}
+	else if (WIDESCREENDELTA > 0 && !st_firsttime)
+	{
+	    V_CopyRect(0, 0, st_backing_screen, WIDESCREENDELTA, ST_HEIGHT, 0, ST_Y);
+	    V_CopyRect(ORIGWIDTH + WIDESCREENDELTA, 0, st_backing_screen, WIDESCREENDELTA, ST_HEIGHT, ORIGWIDTH + WIDESCREENDELTA, ST_Y);
+	}
     }
 
 }
diff -pruN 5.9.2-1/src/doom/wi_stuff.c 5.10.0-1/src/doom/wi_stuff.c
--- 5.9.2-1/src/doom/wi_stuff.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/doom/wi_stuff.c	2021-01-12 08:58:14.000000000 +0000
@@ -868,10 +868,9 @@ void WI_drawShowNextLoc(void)
 	    WI_drawOnLnode(wbs->next, yah); 
     }
 
-    if (crispy->singleplayer && (
-        (gamemission == pack_nerve && wbs->last == 7) ||
+    if ((gamemission == pack_nerve && wbs->last == 7) ||
         (gamemission == pack_master && wbs->last == 19 && !secretexit) ||
-        (gamemission == pack_master && wbs->last == 20)))
+        (gamemission == pack_master && wbs->last == 20))
         return;
 
     // draws which level you are entering..
@@ -1517,8 +1516,8 @@ static boolean WI_drawParTime (void)
 			result = false;
 		}
 
-		// [crispy] PWAD: NRFTL has par times (for singleplayer games)
-		if (gamemission == pack_nerve && crispy->singleplayer)
+		// [crispy] PWAD: NRFTL has par times
+		if (gamemission == pack_nerve)
 		{
 			result = true;
 		}
diff -pruN 5.9.2-1/src/heretic/d_main.c 5.10.0-1/src/heretic/d_main.c
--- 5.9.2-1/src/heretic/d_main.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/d_main.c	2021-01-12 08:58:14.000000000 +0000
@@ -1221,7 +1221,7 @@ void D_DoomMain(void)
     IncThermo();
 
 //
-// start the apropriate game based on parms
+// start the appropriate game based on params
 //
 
     D_CheckRecordFrom();
diff -pruN 5.9.2-1/src/heretic/g_game.c 5.10.0-1/src/heretic/g_game.c
--- 5.9.2-1/src/heretic/g_game.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/g_game.c	2021-01-12 08:58:14.000000000 +0000
@@ -112,7 +112,8 @@ boolean finalintermission; // [crispy] t
 
 int mouseSensitivity;
 
-char demoname[32];
+char *demoname;
+static const char *orig_demoname = NULL; // [crispy] the name originally chosen for the demo, i.e. without "-00000"
 boolean demorecording;
 boolean longtics;               // specify high resolution turning in demos
 boolean lowres_turn;
@@ -1792,6 +1793,14 @@ void G_DeferedInitNew(skill_t skill, int
     d_episode = episode;
     d_map = map;
     gameaction = ga_newgame;
+
+    // [crispy] if a new game is started during demo recording, start a new demo
+    if (demorecording)
+    {
+	G_CheckDemoStatus();
+	Z_Free(demoname);
+	G_RecordDemo(skill, 1, episode, map, orig_demoname);
+    }
 }
 
 void G_DoNewGame(void)
@@ -1857,7 +1866,6 @@ void G_InitNew(skill_t skill, int episod
     gameepisode = episode;
     gamemap = map;
     gameskill = skill;
-    viewactive = true;
     BorderNeedRefresh = true;
 
     // [crispy] total time for all completed levels
@@ -1996,6 +2004,8 @@ void G_WriteDemoTiccmd(ticcmd_t * cmd)
 
     if (demo_p > demoend - 16)
     {
+        // [crispy] unconditionally disable savegame and demo limits
+        /*
         if (vanilla_demo_limit)
         {
             // no more space
@@ -2003,6 +2013,7 @@ void G_WriteDemoTiccmd(ticcmd_t * cmd)
             return;
         }
         else
+        */
         {
             // Vanilla demo limit disabled: unlimited
             // demo lengths!
@@ -2027,9 +2038,20 @@ void G_WriteDemoTiccmd(ticcmd_t * cmd)
 void G_RecordDemo(skill_t skill, int numplayers, int episode, int map,
                   const char *name)
 {
+    size_t demoname_size;
     int i;
     int maxsize;
 
+    // [crispy] demo file name suffix counter
+    static unsigned int j = 0;
+    FILE *fp = NULL;
+
+    // [crispy] the name originally chosen for the demo, i.e. without "-00000"
+    if (!orig_demoname)
+    {
+	orig_demoname = name;
+    }
+
     //!
     // @category demo
     //
@@ -2054,10 +2076,18 @@ void G_RecordDemo(skill_t skill, int num
 
     G_InitNew(skill, episode, map);
     usergame = false;
-    M_StringCopy(demoname, name, sizeof(demoname));
-    M_StringConcat(demoname, ".lmp", sizeof(demoname));
+    demoname_size = strlen(name) + 5 + 6; // [crispy] + 6 for "-00000"
+    demoname = Z_Malloc(demoname_size, PU_STATIC, NULL);
+    M_snprintf(demoname, demoname_size, "%s.lmp", name);
     maxsize = 0x20000;
 
+    // [crispy] prevent overriding demos by adding a file name suffix
+    for ( ; j <= 99999 && (fp = fopen(demoname, "rb")) != NULL; j++)
+    {
+	M_snprintf(demoname, demoname_size, "%s-%05d.lmp", name, j);
+	fclose (fp);
+    }
+
     //!
     // @arg <size>
     // @category demo
@@ -2244,7 +2274,15 @@ boolean G_CheckDemoStatus(void)
         M_WriteFile(demoname, demobuffer, demo_p - demobuffer);
         Z_Free(demobuffer);
         demorecording = false;
+        // [crispy] if a new game is started during demo recording, start a new demo
+        if (gameaction != ga_newgame)
+        {
         I_Error("Demo %s recorded", demoname);
+        }
+        else
+        {
+            fprintf(stderr, "Demo %s recorded\n", demoname);
+        }
     }
 
     return false;
diff -pruN 5.9.2-1/src/heretic/mn_menu.c 5.10.0-1/src/heretic/mn_menu.c
--- 5.9.2-1/src/heretic/mn_menu.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/mn_menu.c	2021-01-12 08:58:14.000000000 +0000
@@ -344,6 +344,7 @@ static int G_ReloadLevel(void)
     if (demorecording)
     {
       gamemap = startmap;
+      gameepisode = startepisode;
     }
     G_DeferedInitNew(gameskill, gameepisode, gamemap);
     result = true;
diff -pruN 5.9.2-1/src/heretic/p_mobj.c 5.10.0-1/src/heretic/p_mobj.c
--- 5.9.2-1/src/heretic/p_mobj.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/p_mobj.c	2021-01-12 08:58:14.000000000 +0000
@@ -1107,7 +1107,7 @@ void P_SpawnMapThing(mapthing_t * mthing
         return;
     }
 
-// check for apropriate skill level
+// check for appropriate skill level
     if (!netgame && (mthing->options & 16))
         return;
 
diff -pruN 5.9.2-1/src/heretic/p_pspr.c 5.10.0-1/src/heretic/p_pspr.c
--- 5.9.2-1/src/heretic/p_pspr.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/p_pspr.c	2021-01-12 08:58:14.000000000 +0000
@@ -1885,12 +1885,11 @@ void P_MovePsprites(player_t * player)
 {
     int i;
     pspdef_t *psp;
-    state_t *state;
 
     psp = &player->psprites[0];
     for (i = 0; i < NUMPSPRITES; i++, psp++)
     {
-        if ((state = psp->state) != 0)  // a null state means not active
+        if (psp->state != 0)  // a null state means not active
         {
             // drop tic count and possibly change state
             if (psp->tics != -1)        // a -1 tic count never changes
diff -pruN 5.9.2-1/src/heretic/p_telept.c 5.10.0-1/src/heretic/p_telept.c
--- 5.9.2-1/src/heretic/p_telept.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/p_telept.c	2021-01-12 08:58:14.000000000 +0000
@@ -139,7 +139,6 @@ boolean EV_Teleport(line_t * line, int s
     {
         if (sectors[i].tag == tag)
         {
-            thinker = thinkercap.next;
             for (thinker = thinkercap.next; thinker != &thinkercap;
                  thinker = thinker->next)
             {
diff -pruN 5.9.2-1/src/heretic/r_data.c 5.10.0-1/src/heretic/r_data.c
--- 5.9.2-1/src/heretic/r_data.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/r_data.c	2021-01-12 08:58:14.000000000 +0000
@@ -151,8 +151,6 @@ void R_GenerateComposite(int texnum)
 //
 // composite the columns together
 //
-    patch = texture->patches;
-
     for (i = 0, patch = texture->patches; i < texture->patchcount;
          i++, patch++)
     {
@@ -217,7 +215,6 @@ void R_GenerateLookup(int texnum)
 //
     patchcount = (byte *) Z_Malloc(texture->width, PU_STATIC, &patchcount);
     memset(patchcount, 0, texture->width);
-    patch = texture->patches;
 
     for (i = 0, patch = texture->patches; i < texture->patchcount;
          i++, patch++)
diff -pruN 5.9.2-1/src/heretic/r_draw.c 5.10.0-1/src/heretic/r_draw.c
--- 5.9.2-1/src/heretic/r_draw.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/r_draw.c	2021-01-12 08:58:14.000000000 +0000
@@ -377,6 +377,8 @@ void R_InitBuffer(int width, int height)
         viewwindowy = 0;
     else
         viewwindowy = (SCREENHEIGHT - SBARHEIGHT - height) >> 1;
+    // [crispy] make sure viewwindowy is always an even number
+    viewwindowy &= ~1;
     for (i = 0; i < height; i++)
         ylookup[i] = I_VideoBuffer + (i + viewwindowy) * SCREENWIDTH;
 }
@@ -424,27 +426,27 @@ void R_DrawViewBorder(void)
             dest += (SCREENWIDTH & 63);
         }
     }
-    for (x = (viewwindowx >> crispy->hires); x < ((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires)); x += 16)
+    for (x = (viewwindowx >> crispy->hires); x < (viewwindowx + viewwidth) >> crispy->hires; x += 16)
     {
         V_DrawPatch(x, (viewwindowy >> crispy->hires) - 4,
                     W_CacheLumpName(DEH_String("bordt"), PU_CACHE));
-        V_DrawPatch(x, (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires),
+        V_DrawPatch(x, (viewwindowy + viewheight) >> crispy->hires,
                     W_CacheLumpName(DEH_String("bordb"), PU_CACHE));
     }
-    for (y = (viewwindowy >> crispy->hires); y < ((viewwindowy >> crispy->hires) + (viewheight >> crispy->hires)); y += 16)
+    for (y = (viewwindowy >> crispy->hires); y < (viewwindowy + viewheight) >> crispy->hires; y += 16)
     {
         V_DrawPatch((viewwindowx >> crispy->hires) - 4, y,
                     W_CacheLumpName(DEH_String("bordl"), PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), y,
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, y,
                     W_CacheLumpName(DEH_String("bordr"), PU_CACHE));
     }
     V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) - 4,
                 W_CacheLumpName(DEH_String("bordtl"), PU_CACHE));
-    V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) - 4,
+    V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy >> crispy->hires) - 4,
                 W_CacheLumpName(DEH_String("bordtr"), PU_CACHE));
-    V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires),
+    V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy + viewheight) >> crispy->hires,
                 W_CacheLumpName(DEH_String("bordbr"), PU_CACHE));
-    V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires),
+    V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy + viewheight) >> crispy->hires,
                 W_CacheLumpName(DEH_String("bordbl"), PU_CACHE));
 }
 
@@ -492,23 +494,23 @@ void R_DrawTopBorder(void)
     }
     if ((viewwindowy >> crispy->hires) < 25)
     {
-        for (x = (viewwindowx >> crispy->hires); x < ((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires)); x += 16)
+        for (x = (viewwindowx >> crispy->hires); x < (viewwindowx + viewwidth) >> crispy->hires; x += 16)
         {
             V_DrawPatch(x, (viewwindowy >> crispy->hires) - 4,
                         W_CacheLumpName(DEH_String("bordt"), PU_CACHE));
         }
-        V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires),
+        V_DrawPatch((viewwindowx >> crispy->hires) - 4, viewwindowy >> crispy->hires,
                     W_CacheLumpName(DEH_String("bordl"), PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires),
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, viewwindowy >> crispy->hires,
                     W_CacheLumpName(DEH_String("bordr"), PU_CACHE));
         V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) + 16,
                     W_CacheLumpName(DEH_String("bordl"), PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) + 16,
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy >> crispy->hires) + 16,
                     W_CacheLumpName(DEH_String("bordr"), PU_CACHE));
 
         V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) - 4,
                     W_CacheLumpName(DEH_String("bordtl"), PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) - 4,
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy >> crispy->hires) - 4,
                     W_CacheLumpName(DEH_String("bordtr"), PU_CACHE));
     }
 }
diff -pruN 5.9.2-1/src/heretic/r_main.c 5.10.0-1/src/heretic/r_main.c
--- 5.9.2-1/src/heretic/r_main.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/heretic/r_main.c	2021-01-12 08:58:14.000000000 +0000
@@ -585,6 +585,8 @@ void R_ExecuteSetViewSize(void)
         scaledviewwidth = (setblocks * 32) << crispy->hires;
         viewheight = ((setblocks * 158 / 10)) << crispy->hires;
     }
+    // [crispy] make sure viewheight is always an even number
+    viewheight &= ~1;
 
     detailshift = setdetail;
     viewwidth = scaledviewwidth >> detailshift;
diff -pruN 5.9.2-1/src/hexen/g_game.c 5.10.0-1/src/hexen/g_game.c
--- 5.9.2-1/src/hexen/g_game.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/g_game.c	2021-01-12 08:58:14.000000000 +0000
@@ -92,7 +92,7 @@ int consoleplayer;              // playe
 int displayplayer;              // view being displayed
 int levelstarttic;              // gametic at level start
 
-char demoname[32];
+char *demoname;
 boolean demorecording;
 boolean longtics;               // specify high resolution turning in demos
 boolean lowres_turn;
@@ -1922,6 +1922,8 @@ void G_WriteDemoTiccmd(ticcmd_t * cmd)
 
     if (demo_p > demoend - 16)
     {
+        // [crispy] unconditionally disable savegame and demo limits
+        /*
         if (vanilla_demo_limit)
         {
             // no more space
@@ -1929,6 +1931,7 @@ void G_WriteDemoTiccmd(ticcmd_t * cmd)
             return;
         }
         else
+        */
         {
             // Vanilla demo limit disabled: unlimited
             // demo lengths!
@@ -1953,6 +1956,7 @@ void G_WriteDemoTiccmd(ticcmd_t * cmd)
 void G_RecordDemo(skill_t skill, int numplayers, int episode, int map,
                   const char *name)
 {
+    size_t demoname_size;
     int i;
     int maxsize;
 
@@ -1980,8 +1984,9 @@ void G_RecordDemo(skill_t skill, int num
 
     G_InitNew(skill, episode, map);
     usergame = false;
-    M_StringCopy(demoname, name, sizeof(demoname));
-    M_StringConcat(demoname, ".lmp", sizeof(demoname));
+    demoname_size = strlen(name) + 5;
+    demoname = Z_Malloc(demoname_size, PU_STATIC, NULL);
+    M_snprintf(demoname, demoname_size, "%s.lmp", name);
     maxsize = 0x20000;
 
     //!
diff -pruN 5.9.2-1/src/hexen/p_lights.c 5.10.0-1/src/hexen/p_lights.c
--- 5.9.2-1/src/hexen/p_lights.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/p_lights.c	2021-01-12 08:58:14.000000000 +0000
@@ -137,7 +137,6 @@ boolean EV_SpawnLight(line_t * line, byt
 
     secNum = -1;
     rtn = false;
-    think = false;
     while ((secNum = P_FindSectorFromTag(arg[0], secNum)) >= 0)
     {
         think = false;
diff -pruN 5.9.2-1/src/hexen/p_pspr.c 5.10.0-1/src/hexen/p_pspr.c
--- 5.9.2-1/src/hexen/p_pspr.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/p_pspr.c	2021-01-12 08:58:14.000000000 +0000
@@ -2457,12 +2457,11 @@ void P_MovePsprites(player_t * player)
 {
     int i;
     pspdef_t *psp;
-    state_t *state;
 
     psp = &player->psprites[0];
     for (i = 0; i < NUMPSPRITES; i++, psp++)
     {
-        if ((state = psp->state) != 0)  // a null state means not active
+        if (psp->state != 0)  // a null state means not active
         {
             // drop tic count and possibly change state
             if (psp->tics != -1)        // a -1 tic count never changes
diff -pruN 5.9.2-1/src/hexen/p_spec.c 5.10.0-1/src/hexen/p_spec.c
--- 5.9.2-1/src/hexen/p_spec.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/p_spec.c	2021-01-12 08:58:14.000000000 +0000
@@ -865,7 +865,6 @@ boolean P_ActivateLine(line_t * line, mo
             return false;       // never open secret doors
     }
     repeat = (line->flags & ML_REPEAT_SPECIAL) != 0;
-    buttonSuccess = false;
 
     // Construct args[] array to contain the arguments from the line, as we
     // cannot rely on struct field ordering and layout.
diff -pruN 5.9.2-1/src/hexen/r_data.c 5.10.0-1/src/hexen/r_data.c
--- 5.9.2-1/src/hexen/r_data.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/r_data.c	2021-01-12 08:58:14.000000000 +0000
@@ -145,8 +145,6 @@ void R_GenerateComposite(int texnum)
 //
 // composite the columns together
 //
-    patch = texture->patches;
-
     for (i = 0, patch = texture->patches; i < texture->patchcount;
          i++, patch++)
     {
@@ -211,8 +209,6 @@ void R_GenerateLookup(int texnum)
 //
     patchcount = (byte *) Z_Malloc(texture->width, PU_STATIC, &patchcount);
     memset(patchcount, 0, texture->width);
-    patch = texture->patches;
-
     for (i = 0, patch = texture->patches; i < texture->patchcount;
          i++, patch++)
     {
diff -pruN 5.9.2-1/src/hexen/r_draw.c 5.10.0-1/src/hexen/r_draw.c
--- 5.9.2-1/src/hexen/r_draw.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/r_draw.c	2021-01-12 08:58:14.000000000 +0000
@@ -428,6 +428,8 @@ void R_InitBuffer(int width, int height)
         viewwindowy = 0;
     else
         viewwindowy = (SCREENHEIGHT - SBARHEIGHT - height) >> 1;
+    // [crispy] make sure viewwindowy is always an even number
+    viewwindowy &= ~1;
     for (i = 0; i < height; i++)
         ylookup[i] = I_VideoBuffer + (i + viewwindowy) * SCREENWIDTH;
 }
@@ -468,25 +470,25 @@ void R_DrawViewBorder(void)
             dest += (SCREENWIDTH & 63);
         }
     }
-    for (x = (viewwindowx >> crispy->hires); x < (viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires); x += 16)
+    for (x = (viewwindowx >> crispy->hires); x < (viewwindowx + viewwidth) >> crispy->hires; x += 16)
     {
         V_DrawPatch(x, (viewwindowy >> crispy->hires) - 4, W_CacheLumpName("bordt", PU_CACHE));
-        V_DrawPatch(x, (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires), W_CacheLumpName("bordb",
+        V_DrawPatch(x, (viewwindowy + viewheight) >> crispy->hires, W_CacheLumpName("bordb",
                                                                  PU_CACHE));
     }
-    for (y = (viewwindowy >> crispy->hires); y < (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires); y += 16)
+    for (y = (viewwindowy >> crispy->hires); y < (viewwindowy + viewheight) >> crispy->hires; y += 16)
     {
         V_DrawPatch((viewwindowx >> crispy->hires) - 4, y, W_CacheLumpName("bordl", PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), y, W_CacheLumpName("bordr",
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, y, W_CacheLumpName("bordr",
                                                                 PU_CACHE));
     }
     V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) - 4, W_CacheLumpName("bordtl",
                                                                   PU_CACHE));
-    V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) - 4,
+    V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy >> crispy->hires) - 4,
                 W_CacheLumpName("bordtr", PU_CACHE));
-    V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires),
+    V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy + viewheight) >> crispy->hires,
                 W_CacheLumpName("bordbr", PU_CACHE));
-    V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) + (viewheight >> crispy->hires),
+    V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy + viewheight) >> crispy->hires,
                 W_CacheLumpName("bordbl", PU_CACHE));
 }
 
@@ -536,23 +538,23 @@ void R_DrawTopBorder(void)
     }
     if (viewwindowy < 35)
     {
-        for (x = (viewwindowx >> crispy->hires); x < (viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires); x += 16)
+        for (x = (viewwindowx >> crispy->hires); x < (viewwindowx + viewwidth) >> crispy->hires; x += 16)
         {
             V_DrawPatch(x, (viewwindowy >> crispy->hires) - 4,
                         W_CacheLumpName("bordt", PU_CACHE));
         }
-        V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires), W_CacheLumpName("bordl",
+        V_DrawPatch((viewwindowx >> crispy->hires) - 4, viewwindowy >> crispy->hires, W_CacheLumpName("bordl",
                                                                   PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires),
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, viewwindowy >> crispy->hires,
                     W_CacheLumpName("bordr", PU_CACHE));
         V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) + 16,
                     W_CacheLumpName("bordl", PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) + 16,
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy >> crispy->hires) + 16,
                     W_CacheLumpName("bordr", PU_CACHE));
 
         V_DrawPatch((viewwindowx >> crispy->hires) - 4, (viewwindowy >> crispy->hires) - 4,
                     W_CacheLumpName("bordtl", PU_CACHE));
-        V_DrawPatch((viewwindowx >> crispy->hires) + (viewwidth >> crispy->hires), (viewwindowy >> crispy->hires) - 4,
+        V_DrawPatch((viewwindowx + viewwidth) >> crispy->hires, (viewwindowy >> crispy->hires) - 4,
                     W_CacheLumpName("bordtr", PU_CACHE));
     }
 }
diff -pruN 5.9.2-1/src/hexen/r_main.c 5.10.0-1/src/hexen/r_main.c
--- 5.9.2-1/src/hexen/r_main.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/hexen/r_main.c	2021-01-12 08:58:14.000000000 +0000
@@ -563,6 +563,8 @@ void R_ExecuteSetViewSize(void)
         scaledviewwidth = (setblocks * 32) << crispy->hires;
         viewheight = (setblocks * 161 / 10) << crispy->hires;
     }
+    // [crispy] make sure viewheight is always an even number
+    viewheight &= ~1;
 
     detailshift = setdetail;
     viewwidth = scaledviewwidth >> detailshift;
diff -pruN 5.9.2-1/src/i_video.c 5.10.0-1/src/i_video.c
--- 5.9.2-1/src/i_video.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/i_video.c	2021-01-12 08:58:14.000000000 +0000
@@ -1551,6 +1551,24 @@ void I_GetScreenDimensions (void)
 	// [crispy] widescreen rendering makes no sense without aspect ratio correction
 	if (crispy->widescreen && aspect_ratio_correct)
 	{
+		switch(crispy->widescreen)
+		{
+			case RATIO_16_10:
+				w = 16;
+				h = 10;
+				break;
+			case RATIO_16_9:
+				w = 16;
+				h = 9;
+				break;
+			case RATIO_21_9:
+				w = 21;
+				h = 9;
+				break;
+			default:
+				break;
+		}
+
 		SCREENWIDTH = w * ah / h;
 		// [crispy] make sure SCREENWIDTH is an integer multiple of 4 ...
 		SCREENWIDTH = (SCREENWIDTH + 3) & (int)~3;
diff -pruN 5.9.2-1/src/m_misc.c 5.10.0-1/src/m_misc.c
--- 5.9.2-1/src/m_misc.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/m_misc.c	2021-01-12 08:58:14.000000000 +0000
@@ -661,3 +661,46 @@ char *M_OEMToUTF8(const char *oem)
 
 #endif
 
+//
+// M_NormalizeSlashes
+//
+// Remove trailing slashes, translate backslashes to slashes
+// The string to normalize is passed and returned in str
+//
+// killough 11/98: rewritten
+//
+// [STRIFE] - haleyjd 20110210: Borrowed from Eternity and adapted to respect
+// the DIR_SEPARATOR define used by Choco Doom. This routine originated in
+// BOOM.
+//
+void M_NormalizeSlashes(char *str)
+{
+    char *p;
+
+    // Convert all slashes/backslashes to DIR_SEPARATOR
+    for (p = str; *p; p++)
+    {
+        if ((*p == '/' || *p == '\\') && *p != DIR_SEPARATOR)
+        {
+            *p = DIR_SEPARATOR;
+        }
+    }
+
+    // Remove trailing slashes
+    while (p > str && *--p == DIR_SEPARATOR)
+    {
+        *p = 0;
+    }
+
+    // Collapse multiple slashes
+    for (p = str; (*str++ = *p); )
+    {
+        if (*p++ == DIR_SEPARATOR)
+        {
+            while (*p == DIR_SEPARATOR)
+            {
+                p++;
+            }
+        }
+    }
+}
\ No newline at end of file
diff -pruN 5.9.2-1/src/m_misc.h 5.10.0-1/src/m_misc.h
--- 5.9.2-1/src/m_misc.h	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/m_misc.h	2021-01-12 08:58:14.000000000 +0000
@@ -50,6 +50,7 @@ boolean M_StringEndsWith(const char *s,
 int M_vsnprintf(char *buf, size_t buf_len, const char *s, va_list args);
 int M_snprintf(char *buf, size_t buf_len, const char *s, ...) PRINTF_ATTR(3, 4);
 char *M_OEMToUTF8(const char *ansi);
+void M_NormalizeSlashes(char *str);
 
 #endif
 
diff -pruN 5.9.2-1/src/strife/g_game.c 5.10.0-1/src/strife/g_game.c
--- 5.9.2-1/src/strife/g_game.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/g_game.c	2021-01-12 08:58:14.000000000 +0000
@@ -1844,6 +1844,8 @@ void G_DoSaveGame (char *path)
 
     P_WriteSaveGameEOF();
 
+    // [crispy] unconditionally disable savegame and demo limits
+    /*
     // Enforce the same savegame size limit as in Vanilla Doom, 
     // except if the vanilla_savegame_limit setting is turned off.
     // [STRIFE]: Verified subject to same limit.
@@ -1852,6 +1854,7 @@ void G_DoSaveGame (char *path)
     {
         I_Error ("Savegame buffer overrun");
     }
+    */
     
     // Finish up, close the savegame file.
 
@@ -2163,6 +2166,8 @@ void G_WriteDemoTiccmd (ticcmd_t* cmd)
 
     if (demo_p > demoend - 16)
     {
+        // [crispy] unconditionally disable savegame and demo limits
+        /*
         if (vanilla_demo_limit)
         {
             // no more space 
@@ -2170,6 +2175,7 @@ void G_WriteDemoTiccmd (ticcmd_t* cmd)
             return; 
         }
         else
+        */
         {
             // Vanilla demo limit disabled: unlimited
             // demo lengths!
diff -pruN 5.9.2-1/src/strife/m_saves.c 5.10.0-1/src/strife/m_saves.c
--- 5.9.2-1/src/strife/m_saves.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/m_saves.c	2021-01-12 08:58:14.000000000 +0000
@@ -362,40 +362,6 @@ int M_StringAlloc(char **str, int numstr
 }
 
 //
-// M_NormalizeSlashes
-//
-// Remove trailing slashes, translate backslashes to slashes
-// The string to normalize is passed and returned in str
-//
-// killough 11/98: rewritten
-//
-// [STRIFE] - haleyjd 20110210: Borrowed from Eternity and adapted to respect 
-// the DIR_SEPARATOR define used by Choco Doom. This routine originated in
-// BOOM.
-//
-void M_NormalizeSlashes(char *str)
-{
-    char *p;
-   
-    // Convert all slashes/backslashes to DIR_SEPARATOR
-    for(p = str; *p; p++)
-    {
-        if((*p == '/' || *p == '\\') && *p != DIR_SEPARATOR)
-            *p = DIR_SEPARATOR;
-    }
-
-    // Remove trailing slashes
-    while(p > str && *--p == DIR_SEPARATOR)
-        *p = 0;
-
-    // Collapse multiple slashes
-    for(p = str; (*str++ = *p); )
-        if(*p++ == DIR_SEPARATOR)
-            while(*p == DIR_SEPARATOR)
-                p++;
-}
-
-//
 // M_SafeFilePath
 //
 // haleyjd 20110210 - original routine.
diff -pruN 5.9.2-1/src/strife/m_saves.h 5.10.0-1/src/strife/m_saves.h
--- 5.9.2-1/src/strife/m_saves.h	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/m_saves.h	2021-01-12 08:58:14.000000000 +0000
@@ -42,7 +42,6 @@ void    M_ReadMisObj(void);
 
 // Custom Utilities for Filepath Handling
 void *M_Calloc(size_t n1, size_t n2);
-void  M_NormalizeSlashes(char *str);
 int   M_StringAlloc(char **str, int numstrs, size_t extra, const char *str1, ...);
 char *M_SafeFilePath(const char *basepath, const char *newcomponent);
 char  M_GetFilePath(const char *fn, char *dest, size_t len);
diff -pruN 5.9.2-1/src/strife/p_mobj.c 5.10.0-1/src/strife/p_mobj.c
--- 5.9.2-1/src/strife/p_mobj.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/p_mobj.c	2021-01-12 08:58:14.000000000 +0000
@@ -946,7 +946,7 @@ void P_SpawnMapThing (mapthing_t* mthing
         return;
     }
 
-    // check for apropriate skill level
+    // check for appropriate skill level
     if (!netgame && (mthing->options & 16) )
         return;
 
diff -pruN 5.9.2-1/src/strife/p_pspr.c 5.10.0-1/src/strife/p_pspr.c
--- 5.9.2-1/src/strife/p_pspr.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/p_pspr.c	2021-01-12 08:58:14.000000000 +0000
@@ -970,13 +970,12 @@ void P_MovePsprites (player_t* player)
 {
     int		i;
     pspdef_t*	psp;
-    state_t*	state;
 
     psp = &player->psprites[0];
     for(i = 0; i < NUMPSPRITES; i++, psp++)
     {
         // a null state means not active
-        if((state = psp->state))	
+        if(psp->state)
         {
             // drop tic count and possibly change state
 
diff -pruN 5.9.2-1/src/strife/p_telept.c 5.10.0-1/src/strife/p_telept.c
--- 5.9.2-1/src/strife/p_telept.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/p_telept.c	2021-01-12 08:58:14.000000000 +0000
@@ -75,7 +75,6 @@ EV_Teleport
     {
         if (sectors[ i ].tag == tag )
         {
-            thinker = thinkercap.next;
             for (thinker = thinkercap.next;
                 thinker != &thinkercap;
                 thinker = thinker->next)
diff -pruN 5.9.2-1/src/strife/r_data.c 5.10.0-1/src/strife/r_data.c
--- 5.9.2-1/src/strife/r_data.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/strife/r_data.c	2021-01-12 08:58:14.000000000 +0000
@@ -243,8 +243,6 @@ void R_GenerateComposite (int texnum)
     colofs = texturecolumnofs[texnum];
     
     // Composite the columns together.
-    patch = texture->patches;
-		
     for (i=0 , patch = texture->patches;
 	 i<texture->patchcount;
 	 i++, patch++)
@@ -315,7 +313,6 @@ void R_GenerateLookup (int texnum)
     //  with only a single patch are all done.
     patchcount = (byte *) Z_Malloc(texture->width, PU_STATIC, &patchcount);
     memset (patchcount, 0, texture->width);
-    patch = texture->patches;
 
     for (i=0 , patch = texture->patches;
 	 i<texture->patchcount;
diff -pruN 5.9.2-1/src/v_video.c 5.10.0-1/src/v_video.c
--- 5.9.2-1/src/v_video.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/src/v_video.c	2021-01-12 08:58:14.000000000 +0000
@@ -236,20 +236,23 @@ void V_DrawPatch(int x, int y, patch_t *
     V_MarkRect(x, y, SHORT(patch->width), SHORT(patch->height));
 
     col = 0;
+    if (x < 0)
+    {
+	col += dxi * ((-x * dx) >> FRACBITS);
+	x = 0;
+    }
+
     desttop = dest_screen + ((y * dy) >> FRACBITS) * SCREENWIDTH + ((x * dx) >> FRACBITS);
 
     w = SHORT(patch->width);
 
+    // convert x to screen position
+    x = (x * dx) >> FRACBITS;
+
     for ( ; col<w << FRACBITS ; x++, col+=dxi, desttop++)
     {
         int topdelta = -1;
 
-        // [crispy] too far left
-        if (x < 0)
-        {
-            continue;
-        }
-
         // [crispy] too far right / width
         if (x >= SCREENWIDTH)
         {
@@ -305,13 +308,7 @@ void V_DrawPatch(int x, int y, patch_t *
 
 void V_DrawPatchFullScreen(patch_t *patch, boolean flipped)
 {
-    const short width = SHORT(patch->width);
-    const short height = SHORT(patch->height);
-
-    dx = (NONWIDEWIDTH << FRACBITS) / ORIGWIDTH;
-    dxi = (width << FRACBITS) / NONWIDEWIDTH;
-    dy = (SCREENHEIGHT << FRACBITS) / height;
-    dyi = (height << FRACBITS) / SCREENHEIGHT;
+    int x = ((SCREENWIDTH >> crispy->hires) - patch->width) / 2 - WIDESCREENDELTA;
 
     patch->leftoffset = 0;
     patch->topoffset = 0;
@@ -324,17 +321,12 @@ void V_DrawPatchFullScreen(patch_t *patc
 
     if (flipped)
     {
-        V_DrawPatchFlipped(0, 0, patch);
+        V_DrawPatchFlipped(x, 0, patch);
     }
     else
     {
-        V_DrawPatch(0, 0, patch);
+        V_DrawPatch(x, 0, patch);
     }
-
-    dx = (NONWIDEWIDTH << FRACBITS) / ORIGWIDTH;
-    dxi = (ORIGWIDTH << FRACBITS) / NONWIDEWIDTH;
-    dy = (SCREENHEIGHT << FRACBITS) / ORIGHEIGHT;
-    dyi = (ORIGHEIGHT << FRACBITS) / SCREENHEIGHT;
 }
 
 //
@@ -377,10 +369,19 @@ void V_DrawPatchFlipped(int x, int y, pa
     V_MarkRect (x, y, SHORT(patch->width), SHORT(patch->height));
 
     col = 0;
+    if (x < 0)
+    {
+	col += dxi * ((-x * dx) >> FRACBITS);
+	x = 0;
+    }
+
     desttop = dest_screen + ((y * dy) >> FRACBITS) * SCREENWIDTH + ((x * dx) >> FRACBITS);
 
     w = SHORT(patch->width);
 
+    // convert x to screen position
+    x = (x * dx) >> FRACBITS;
+
     for ( ; col<w << FRACBITS ; x++, col+=dxi, desttop++)
     {
         int topdelta = -1;
diff -pruN 5.9.2-1/textscreen/fonts/convert-font 5.10.0-1/textscreen/fonts/convert-font
--- 5.9.2-1/textscreen/fonts/convert-font	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/textscreen/fonts/convert-font	2021-01-12 08:58:14.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 #
 # Copyright(C) 2016 Simon Howard
 #
diff -pruN 5.9.2-1/textscreen/txt_inputbox.c 5.10.0-1/textscreen/txt_inputbox.c
--- 5.9.2-1/textscreen/txt_inputbox.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/textscreen/txt_inputbox.c	2021-01-12 08:58:14.000000000 +0000
@@ -37,7 +37,7 @@ static void SetBufferFromValue(txt_input
 
         if (*value != NULL)
         {
-            TXT_StringCopy(inputbox->buffer, *value, inputbox->size);
+            TXT_StringCopy(inputbox->buffer, *value, strnlen(*value, inputbox->buffer_len) + 1);
         }
         else
         {
diff -pruN 5.9.2-1/textscreen/txt_sdl.c 5.10.0-1/textscreen/txt_sdl.c
--- 5.9.2-1/textscreen/txt_sdl.c	2020-09-21 06:16:44.000000000 +0000
+++ 5.10.0-1/textscreen/txt_sdl.c	2021-01-12 08:58:14.000000000 +0000
@@ -253,7 +253,7 @@ int TXT_Init(void)
     if (TXT_SDLWindow == NULL)
         return 0;
 
-    renderer = SDL_CreateRenderer(TXT_SDLWindow, -1, 0);
+    renderer = SDL_CreateRenderer(TXT_SDLWindow, -1, SDL_RENDERER_SOFTWARE);
 
     // Special handling for OS X retina display. If we successfully set the
     // highdpi flag, check the output size for the screen renderer. If we get
